/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/platform","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/types","vs/base/common/errors","vs/base/common/event","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/uint","vs/base/common/uri","vs/editor/common/core/characterClassifier","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/objects","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/modes/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],x=function(U){for(var t=[],R=0,S=U.length;R<S;R++)t[R]=K[U[R]];return t},De=this,Re=typeof global=="object"?global:{},ce;(function(U){U.global=De;var t=function(){function R(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(R.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),R.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=R._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof U.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},R._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},R}();U.Environment=t})(ce||(ce={}));var ce;(function(U){var t=function(){function D(l,M,_){this.type=l,this.detail=M,this.timestamp=_}return D}();U.LoaderEvent=t;var R=function(){function D(l){this._events=[new t(1,"",l)]}return D.prototype.record=function(l,M){this._events.push(new t(l,M,U.Utilities.getHighPerformanceTimestamp()))},D.prototype.getEvents=function(){return this._events},D}();U.LoaderEventRecorder=R;var S=function(){function D(){}return D.prototype.record=function(l,M){},D.prototype.getEvents=function(){return[]},D.INSTANCE=new D,D}();U.NullLoaderEventRecorder=S})(ce||(ce={}));var ce;(function(U){var t=function(){function R(){}return R.fileUriToFilePath=function(S,D){if(D=decodeURI(D).replace(/%23/g,"#"),S){if(/^file:\/\/\//.test(D))return D.substr(8);if(/^file:\/\//.test(D))return D.substr(5)}else if(/^file:\/\//.test(D))return D.substr(7);return D},R.startsWith=function(S,D){return S.length>=D.length&&S.substr(0,D.length)===D},R.endsWith=function(S,D){return S.length>=D.length&&S.substr(S.length-D.length)===D},R.containsQueryString=function(S){return/^[^\#]*\?/gi.test(S)},R.isAbsolutePath=function(S){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(S)},R.forEachProperty=function(S,D){if(S){var l=void 0;for(l in S)S.hasOwnProperty(l)&&D(l,S[l])}},R.isEmpty=function(S){var D=!0;return R.forEachProperty(S,function(){D=!1}),D},R.recursiveClone=function(S){if(!S||typeof S!="object"||S instanceof RegExp||!Array.isArray(S)&&Object.getPrototypeOf(S)!==Object.prototype)return S;var D=Array.isArray(S)?[]:{};return R.forEachProperty(S,function(l,M){M&&typeof M=="object"?D[l]=R.recursiveClone(M):D[l]=M}),D},R.generateAnonymousModule=function(){return"===anonymous"+R.NEXT_ANONYMOUS_ID+++"==="},R.isAnonymousModule=function(S){return R.startsWith(S,"===anonymous")},R.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=U.global.performance&&typeof U.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?U.global.performance.now():Date.now()},R.NEXT_ANONYMOUS_ID=1,R.PERFORMANCE_NOW_PROBED=!1,R.HAS_PERFORMANCE_NOW=!1,R}();U.Utilities=t})(ce||(ce={}));var ce;(function(U){function t(D){if(D instanceof Error)return D;var l=new Error(D.message||String(D)||"Unknown Error");return D.stack&&(l.stack=D.stack),l}U.ensureError=t;var R=function(){function D(){}return D.validateConfigurationOptions=function(l){function M(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=M),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(U.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var _=t(new Error("INVALID cached data configuration, 'path' MUST be set"));_.phase="configuration",l.onError(_),l.nodeCachedData=void 0}return l},D.mergeConfigurationOptions=function(l,M){l===void 0&&(l=null),M===void 0&&(M=null);var _=U.Utilities.recursiveClone(M||{});return U.Utilities.forEachProperty(l,function(u,f){u==="ignoreDuplicateModules"&&typeof _.ignoreDuplicateModules!="undefined"?_.ignoreDuplicateModules=_.ignoreDuplicateModules.concat(f):u==="paths"&&typeof _.paths!="undefined"?U.Utilities.forEachProperty(f,function(b,A){return _.paths[b]=A}):u==="config"&&typeof _.config!="undefined"?U.Utilities.forEachProperty(f,function(b,A){return _.config[b]=A}):_[u]=U.Utilities.recursiveClone(f)}),D.validateConfigurationOptions(_)},D}();U.ConfigurationOptionsUtil=R;var S=function(){function D(l,M){if(this._env=l,this.options=R.mergeConfigurationOptions(M),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var _=this.options.nodeRequire.main.filename,u=Math.max(_.lastIndexOf("/"),_.lastIndexOf("\\"));this.options.baseUrl=_.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var _=this.options.nodeMain,u=Math.max(_.lastIndexOf("/"),_.lastIndexOf("\\"));this.options.baseUrl=_.substring(0,u+1)}}}return D.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},D.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,M=this.options.nodeModules;l<M.length;l++){var _=M[l];this.nodeModulesMap[_]=!0}},D.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],U.Utilities.forEachProperty(this.options.paths,function(M,_){Array.isArray(_)?l.sortedPathsRules.push({from:M,to:_}):l.sortedPathsRules.push({from:M,to:[_]})}),this.sortedPathsRules.sort(function(M,_){return _.from.length-M.from.length})},D.prototype.cloneAndMerge=function(l){return new D(this._env,R.mergeConfigurationOptions(l,this.options))},D.prototype.getOptionsLiteral=function(){return this.options},D.prototype._applyPaths=function(l){for(var M,_=0,u=this.sortedPathsRules.length;_<u;_++)if(M=this.sortedPathsRules[_],U.Utilities.startsWith(l,M.from)){for(var f=[],b=0,A=M.to.length;b<A;b++)f.push(M.to[b]+l.substr(M.from.length));return f}return[l]},D.prototype._addUrlArgsToUrl=function(l){return U.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},D.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},D.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var M=0,_=l.length;M<_;M++)l[M]=this._addUrlArgsToUrl(l[M]);return l},D.prototype.moduleIdToPaths=function(l){if(this._env.isNode){var M=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(M)return this.isBuild()?["empty:"]:["node|"+l]}var _=l,u;if(!U.Utilities.endsWith(_,".js")&&!U.Utilities.isAbsolutePath(_)){u=this._applyPaths(_);for(var f=0,b=u.length;f<b;f++)this.isBuild()&&u[f]==="empty:"||(U.Utilities.isAbsolutePath(u[f])||(u[f]=this.options.baseUrl+u[f]),!U.Utilities.endsWith(u[f],".js")&&!U.Utilities.containsQueryString(u[f])&&(u[f]=u[f]+".js"))}else!U.Utilities.endsWith(_,".js")&&!U.Utilities.containsQueryString(_)&&(_=_+".js"),u=[_];return this._addUrlArgsIfNecessaryToUrls(u)},D.prototype.requireToUrl=function(l){var M=l;return U.Utilities.isAbsolutePath(M)||(M=this._applyPaths(M)[0],U.Utilities.isAbsolutePath(M)||(M=this.options.baseUrl+M)),this._addUrlArgsIfNecessaryToUrl(M)},D.prototype.isBuild=function(){return this.options.isBuild},D.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},D.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},D.prototype.shouldCatchError=function(){return this.options.catchError},D.prototype.shouldRecordStats=function(){return this.options.recordStats},D.prototype.onError=function(l){this.options.onError(l)},D}();U.Configuration=S})(ce||(ce={}));var ce;(function(U){var t=function(){function u(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(f,b,A,v){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){var e=f.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new R:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new R;var g={callback:A,errorback:v};if(this._callbackMap.hasOwnProperty(b)){this._callbackMap[b].push(g);return}this._callbackMap[b]=[g],this._scriptLoader.load(f,b,function(){return m.triggerCallback(b)},function(N){return m.triggerErrorback(b,N)})},u.prototype.triggerCallback=function(f){var b=this._callbackMap[f];delete this._callbackMap[f];for(var A=0;A<b.length;A++)b[A].callback()},u.prototype.triggerErrorback=function(f,b){var A=this._callbackMap[f];delete this._callbackMap[f];for(var v=0;v<A.length;v++)A[v].errorback(b)},u}(),R=function(){function u(){}return u.prototype.attachListeners=function(f,b,A){var v=function(){f.removeEventListener("load",m),f.removeEventListener("error",e)},m=function(g){v(),b()},e=function(g){v(),A(g)};f.addEventListener("load",m),f.addEventListener("error",e)},u.prototype.load=function(f,b,A,v){if(/^node\|/.test(b)){var m=f.getConfig().getOptionsLiteral(),e=M(f.getRecorder(),m.nodeRequire||U.global.nodeRequire),g=b.split("|"),N=null;try{N=e(g[1])}catch(i){v(i);return}f.enqueueDefineAnonymousModule([],function(){return N}),A()}else{var L=document.createElement("script");L.setAttribute("async","async"),L.setAttribute("type","text/javascript"),this.attachListeners(L,A,v);var w=f.getConfig().getOptionsLiteral().trustedTypesPolicy;w&&(b=w.createScriptURL(b)),L.setAttribute("src",b);var s=f.getConfig().getOptionsLiteral().cspNonce;s&&L.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(L)}},u}();function S(u){var f=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var b=f?self.eval(f.createScript("","true")):new Function("true");return b.call(self),!0}catch(A){return!1}}var D=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=S(f)),this._cachedCanUseEval},u.prototype.load=function(f,b,A,v){if(/^node\|/.test(b)){var m=f.getConfig().getOptionsLiteral(),e=M(f.getRecorder(),m.nodeRequire||U.global.nodeRequire),g=b.split("|"),N=null;try{N=e(g[1])}catch(s){v(s);return}f.enqueueDefineAnonymousModule([],function(){return N}),A()}else{var L=f.getConfig().getOptionsLiteral().trustedTypesPolicy,w=/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,self.origin.length)!==self.origin;if(!w&&this._canUseEval(f)){fetch(b).then(function(s){if(s.status!==200)throw new Error(s.statusText);return s.text()}).then(function(s){s=s+`
//# sourceURL=`+b;var i=L?self.eval(L.createScript("",s)):new Function(s);i.call(self),A()}).then(void 0,v);return}try{L&&(b=L.createScriptURL(b)),importScripts(b),A()}catch(s){v(s)}}},u}(),l=function(){function u(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},u.prototype._initNodeRequire=function(f,b){var A=b.getConfig().getOptionsLiteral().nodeCachedData;if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var v=this,m=f("module");function e(g){var N=g.constructor,L=function(s){try{return g.require(s)}finally{}};return L.resolve=function(s,i){return N._resolveFilename(s,g,!1,i)},L.resolve.paths=function(s){return N._resolveLookupPaths(s,g)},L.main=process.mainModule,L.extensions=N._extensions,L.cache=N._cache,L}m.prototype._compile=function(g,N){var L=m.wrap(g.replace(/^#!.*/,"")),w=b.getRecorder(),s=v._getCachedDataPath(A,N),i={filename:N},r;try{var a=v._fs.readFileSync(s);r=a.slice(0,16),i.cachedData=a.slice(16),w.record(60,s)}catch(F){w.record(61,s)}var d=new v._vm.Script(L,i),h=d.runInThisContext(i),o=v._path.dirname(N),c=e(this),E=[this.exports,c,this,N,o,process,Re,Buffer],P=h.apply(this.exports,E);return v._handleCachedData(d,L,s,!i.cachedData,b),v._verifyCachedData(d,L,s,r,b),P}},u.prototype.load=function(f,b,A,v){var m=this,e=f.getConfig().getOptionsLiteral(),g=M(f.getRecorder(),e.nodeRequire||U.global.nodeRequire),N=e.nodeInstrumenter||function(h){return h};this._init(g),this._initNodeRequire(g,f);var L=f.getRecorder();if(/^node\|/.test(b)){var w=b.split("|"),s=null;try{s=g(w[1])}catch(h){v(h);return}f.enqueueDefineAnonymousModule([],function(){return s}),A()}else{b=U.Utilities.fileUriToFilePath(this._env.isWindows,b);var i=this._path.normalize(b),r=this._getElectronRendererScriptPathOrUri(i),a=Boolean(e.nodeCachedData),d=a?this._getCachedDataPath(e.nodeCachedData,b):void 0;this._readSourceAndCachedData(i,d,L,function(h,o,c,E){if(h){v(h);return}var P;o.charCodeAt(0)===u._BOM?P=u._PREFIX+o.substring(1)+u._SUFFIX:P=u._PREFIX+o+u._SUFFIX,P=N(P,i);var F={filename:r,cachedData:c},I=m._createAndEvalScript(f,P,F,A,v);m._handleCachedData(I,P,d,a&&!c,f),m._verifyCachedData(I,P,d,E,f)})}},u.prototype._createAndEvalScript=function(f,b,A,v,m){var e=f.getRecorder();e.record(31,A.filename);var g=new this._vm.Script(b,A),N=g.runInThisContext(A),L=f.getGlobalAMDDefineFunc(),w=!1,s=function(){return w=!0,L.apply(null,arguments)};return s.amd=L.amd,N.call(U.global,f.getGlobalAMDRequireFunc(),s,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),w?v():m(new Error("Didn't receive define call in "+A.filename+"!")),g},u.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var b=f.match(/^([a-z])\:(.*)/i);return b?"file:///"+(b[1].toUpperCase()+":"+b[2]).replace(/\\/g,"/"):"file://"+f},u.prototype._getCachedDataPath=function(f,b){var A=this._crypto.createHash("md5").update(b,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),v=this._path.basename(b).replace(/\.js$/,"");return this._path.join(f.path,v+"-"+A+".code")},u.prototype._handleCachedData=function(f,b,A,v,m){var e=this;f.cachedDataRejected?this._fs.unlink(A,function(g){m.getRecorder().record(62,A),e._createAndWriteCachedData(f,b,A,m),g&&m.getConfig().onError(g)}):v&&this._createAndWriteCachedData(f,b,A,m)},u.prototype._createAndWriteCachedData=function(f,b,A,v){var m=this,e=Math.ceil(v.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),g=-1,N=0,L=void 0,w=function(){setTimeout(function(){L||(L=m._crypto.createHash("md5").update(b,"utf8").digest());var s=f.createCachedData();if(!(s.length===0||s.length===g||N>=5)){if(s.length<g){w();return}g=s.length,m._fs.writeFile(A,Buffer.concat([L,s]),function(i){i&&v.getConfig().onError(i),v.getRecorder().record(63,A),w()})}},e*Math.pow(4,N++))};w()},u.prototype._readSourceAndCachedData=function(f,b,A,v){if(!b)this._fs.readFile(f,{encoding:"utf8"},v);else{var m=void 0,e=void 0,g=void 0,N=2,L=function(w){w?v(w):--N==0&&v(void 0,m,e,g)};this._fs.readFile(f,{encoding:"utf8"},function(w,s){m=s,L(w)}),this._fs.readFile(b,function(w,s){!w&&s&&s.length>0?(g=s.slice(0,16),e=s.slice(16),A.record(60,b)):A.record(61,b),L()})}},u.prototype._verifyCachedData=function(f,b,A,v,m){var e=this;!v||f.cachedDataRejected||setTimeout(function(){var g=e._crypto.createHash("md5").update(b,"utf8").digest();v.equals(g)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+A+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(A,function(N){N&&m.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function M(u,f){if(f.__$__isRecorded)return f;var b=function(v){u.record(33,v);try{return f(v)}finally{u.record(34,v)}};return b.__$__isRecorded=!0,b}U.ensureRecordedNodeRequire=M;function _(u){return new t(u)}U.createScriptLoader=_})(ce||(ce={}));var ce;(function(U){var t=function(){function _(u){var f=u.lastIndexOf("/");f!==-1?this.fromModulePath=u.substr(0,f+1):this.fromModulePath=""}return _._normalizeModuleId=function(u){var f=u,b;for(b=/\/\.\//;b.test(f);)f=f.replace(b,"/");for(f=f.replace(/^\.\//g,""),b=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;b.test(f);)f=f.replace(b,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},_.prototype.resolveModule=function(u){var f=u;return U.Utilities.isAbsolutePath(f)||(U.Utilities.startsWith(f,"./")||U.Utilities.startsWith(f,"../"))&&(f=_._normalizeModuleId(this.fromModulePath+f)),f},_.ROOT=new _(""),_}();U.ModuleIdResolver=t;var R=function(){function _(u,f,b,A,v,m){this.id=u,this.strId=f,this.dependencies=b,this._callback=A,this._errorback=v,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return _._safeInvokeFunction=function(u,f){try{return{returnedValue:u.apply(U.global,f),producedError:null}}catch(b){return{returnedValue:null,producedError:b}}},_._invokeFactory=function(u,f,b,A){return u.isBuild()&&!U.Utilities.isAnonymousModule(f)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(b,A):{returnedValue:b.apply(U.global,A),producedError:null}},_.prototype.complete=function(u,f,b){this._isComplete=!0;var A=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var v=_._invokeFactory(f,this.strId,this._callback,b);A=v.producedError,u.record(22,this.strId),!A&&typeof v.returnedValue!="undefined"&&(!this.exportsPassedIn||U.Utilities.isEmpty(this.exports))&&(this.exports=v.returnedValue)}else this.exports=this._callback;if(A){var m=U.ensureError(A);m.phase="factory",m.moduleId=this.strId,this.error=m,f.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},_.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},_.prototype.isComplete=function(){return this._isComplete},_}();U.Module=R;var S=function(){function _(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return _.prototype.getMaxModuleId=function(){return this._nextId},_.prototype.getModuleId=function(u){var f=this._strModuleIdToIntModuleId.get(u);return typeof f=="undefined"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(u,f),this._intModuleIdToStrModuleId[f]=u),f},_.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},_}(),D=function(){function _(u){this.id=u}return _.EXPORTS=new _(0),_.MODULE=new _(1),_.REQUIRE=new _(2),_}();U.RegularDependency=D;var l=function(){function _(u,f,b){this.id=u,this.pluginId=f,this.pluginParam=b}return _}();U.PluginDependency=l;var M=function(){function _(u,f,b,A,v){v===void 0&&(v=0),this._env=u,this._scriptLoader=f,this._loaderAvailableTimestamp=v,this._defineFunc=b,this._requireFunc=A,this._moduleIdProvider=new S,this._config=new U.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return _.prototype.reset=function(){return new _(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},_.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},_.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},_._findRelevantLocationInStack=function(u,f){for(var b=function(i){return i.replace(/\\/g,"/")},A=b(u),v=f.split(/\n/),m=0;m<v.length;m++){var e=v[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){var g=e[1],N=e[2],L=e[3],w=Math.max(g.lastIndexOf(" ")+1,g.lastIndexOf("(")+1);if(g=g.substr(w),g=b(g),g===A){var s={line:parseInt(N,10),col:parseInt(L,10)};return s.line===1&&(s.col-="(function (require, define, __filename, __dirname) { ".length),s}}}throw new Error("Could not correlate define call site for needle "+u)},_.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],f=0,b=0,A=this._modules2.length;b<A;b++){var v=this._modules2[b];if(!!v){var m=this._buildInfoPath[v.id]||null,e=this._buildInfoDefineStack[v.id]||null,g=this._buildInfoDependencies[v.id];u[f++]={id:v.strId,path:m,defineLocation:m&&e?_._findRelevantLocationInStack(m,e):null,dependencies:g,shim:null,exports:v.exports}}}return u},_.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new U.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=U.NullLoaderEventRecorder.INSTANCE),this._recorder},_.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},_.prototype.enqueueDefineAnonymousModule=function(u,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var b=null;this._config.isBuild()&&(b=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:b,dependencies:u,callback:f}},_.prototype.defineModule=function(u,f,b,A,v,m){var e=this;m===void 0&&(m=new t(u));var g=this._moduleIdProvider.getModuleId(u);if(this._modules2[g]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var N=new R(g,u,this._normalizeDependencies(f,m),b,A,m);this._modules2[g]=N,this._config.isBuild()&&(this._buildInfoDefineStack[g]=v,this._buildInfoDependencies[g]=(N.dependencies||[]).map(function(L){return e._moduleIdProvider.getStrModuleId(L.id)})),this._resolve(N)},_.prototype._normalizeDependency=function(u,f){if(u==="exports")return D.EXPORTS;if(u==="module")return D.MODULE;if(u==="require")return D.REQUIRE;var b=u.indexOf("!");if(b>=0){var A=f.resolveModule(u.substr(0,b)),v=f.resolveModule(u.substr(b+1)),m=this._moduleIdProvider.getModuleId(A+"!"+v),e=this._moduleIdProvider.getModuleId(A);return new l(m,e,v)}return new D(this._moduleIdProvider.getModuleId(f.resolveModule(u)))},_.prototype._normalizeDependencies=function(u,f){for(var b=[],A=0,v=0,m=u.length;v<m;v++)b[A++]=this._normalizeDependency(u[v],f);return b},_.prototype._relativeRequire=function(u,f,b,A){if(typeof f=="string")return this.synchronousRequire(f,u);this.defineModule(U.Utilities.generateAnonymousModule(),f,b,A,null,u)},_.prototype.synchronousRequire=function(u,f){f===void 0&&(f=new t(u));var b=this._normalizeDependency(u,f),A=this._modules2[b.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports},_.prototype.configure=function(u,f){var b=this._config.shouldRecordStats();f?this._config=new U.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!b&&(this._recorder=null)},_.prototype.getConfig=function(){return this._config},_.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),f.dependencies,f.callback,null,f.stack)}},_.prototype._createLoadError=function(u,f){var b=this,A=this._moduleIdProvider.getStrModuleId(u),v=(this._inverseDependencies2[u]||[]).map(function(e){return b._moduleIdProvider.getStrModuleId(e)}),m=U.ensureError(f);return m.phase="loading",m.moduleId=A,m.neededBy=v,m},_.prototype._onLoadError=function(u,f){var b=this._createLoadError(u,f);this._modules2[u]||(this._modules2[u]=new R(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},null,null));for(var A=[],v=0,m=this._moduleIdProvider.getMaxModuleId();v<m;v++)A[v]=!1;var e=!1,g=[];for(g.push(u),A[u]=!0;g.length>0;){var N=g.shift(),L=this._modules2[N];L&&(e=L.onDependencyError(b)||e);var w=this._inverseDependencies2[N];if(w)for(var v=0,m=w.length;v<m;v++){var s=w[v];A[s]||(g.push(s),A[s]=!0)}}e||this._config.onError(b)},_.prototype._hasDependencyPath=function(u,f){var b=this._modules2[u];if(!b)return!1;for(var A=[],v=0,m=this._moduleIdProvider.getMaxModuleId();v<m;v++)A[v]=!1;var e=[];for(e.push(b),A[u]=!0;e.length>0;){var g=e.shift(),N=g.dependencies;if(N)for(var v=0,m=N.length;v<m;v++){var L=N[v];if(L.id===f)return!0;var w=this._modules2[L.id];w&&!A[L.id]&&(A[L.id]=!0,e.push(w))}}return!1},_.prototype._findCyclePath=function(u,f,b){if(u===f||b===50)return[u];var A=this._modules2[u];if(!A)return null;var v=A.dependencies;if(v)for(var m=0,e=v.length;m<e;m++){var g=this._findCyclePath(v[m].id,f,b+1);if(g!==null)return g.push(u),g}return null},_.prototype._createRequire=function(u){var f=this,b=function(A,v,m){return f._relativeRequire(u,A,v,m)};return b.toUrl=function(A){return f._config.requireToUrl(u.resolveModule(A))},b.getStats=function(){return f.getLoaderEvents()},b.hasDependencyCycle=function(){return f._hasDependencyCycle},b.config=function(A,v){v===void 0&&(v=!1),f.configure(A,v)},b.__$__nodeRequire=U.global.nodeRequire,b},_.prototype._loadModule=function(u){var f=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var b=this._moduleIdProvider.getStrModuleId(u),A=this._config.moduleIdToPaths(b),v=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(b.indexOf("/")===-1||v.test(b))&&A.push("node|"+b);var m=-1,e=function(g){if(m++,m>=A.length)f._onLoadError(u,g);else{var N=A[m],L=f.getRecorder();if(f._config.isBuild()&&N==="empty:"){f._buildInfoPath[u]=N,f.defineModule(f._moduleIdProvider.getStrModuleId(u),[],null,null,null),f._onLoad(u);return}L.record(10,N),f._scriptLoader.load(f,N,function(){f._config.isBuild()&&(f._buildInfoPath[u]=N),L.record(11,N),f._onLoad(u)},function(w){L.record(12,N),e(w)})}};e(null)}},_.prototype._loadPluginDependency=function(u,f){var b=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var A=function(v){b.defineModule(b._moduleIdProvider.getStrModuleId(f.id),[],v,null,null)};A.error=function(v){b._config.onError(b._createLoadError(f.id,v))},u.load(f.pluginParam,this._createRequire(t.ROOT),A,this._config.getOptionsLiteral())}},_.prototype._resolve=function(u){var f=this,b=u.dependencies;if(b)for(var A=0,v=b.length;A<v;A++){var m=b[A];if(m===D.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(m===D.MODULE){u.unresolvedDependenciesCount--;continue}if(m===D.REQUIRE){u.unresolvedDependenciesCount--;continue}var e=this._modules2[m.id];if(e&&e.isComplete()){if(e.error){u.onDependencyError(e.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var g=this._findCyclePath(m.id,u.id,0)||[];g.reverse(),g.push(m.id),console.warn(g.map(function(w){return f._moduleIdProvider.getStrModuleId(w)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(u.id),m instanceof l){var N=this._modules2[m.pluginId];if(N&&N.isComplete()){this._loadPluginDependency(N.exports,m);continue}var L=this._inversePluginDependencies2.get(m.pluginId);L||(L=[],this._inversePluginDependencies2.set(m.pluginId,L)),L.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},_.prototype._onModuleComplete=function(u){var f=this,b=this.getRecorder();if(!u.isComplete()){var A=u.dependencies,v=[];if(A)for(var m=0,e=A.length;m<e;m++){var g=A[m];if(g===D.EXPORTS){v[m]=u.exports;continue}if(g===D.MODULE){v[m]={id:u.strId,config:function(){return f._config.getConfigForModule(u.strId)}};continue}if(g===D.REQUIRE){v[m]=this._createRequire(u.moduleIdResolver);continue}var N=this._modules2[g.id];if(N){v[m]=N.exports;continue}v[m]=null}u.complete(b,this._config,v);var L=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,L)for(var m=0,e=L.length;m<e;m++){var w=L[m],s=this._modules2[w];s.unresolvedDependenciesCount--,s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}var i=this._inversePluginDependencies2.get(u.id);if(i){this._inversePluginDependencies2.delete(u.id);for(var m=0,e=i.length;m<e;m++)this._loadPluginDependency(u.exports,i[m])}}},_}();U.ModuleManager=M})(ce||(ce={}));var J,ce;(function(U){var t=new U.Environment,R=null,S=function(_,u,f){typeof _!="string"&&(f=u,u=_,_=null),(typeof u!="object"||!Array.isArray(u))&&(f=u,u=null),u||(u=["require","exports","module"]),_?R.defineModule(_,u,f,null,null):R.enqueueDefineAnonymousModule(u,f)};S.amd={jQuery:!0};var D=function(_,u){u===void 0&&(u=!1),R.configure(_,u)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){D(arguments[0]);return}if(typeof arguments[0]=="string")return R.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){R.defineModule(U.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=D,l.getConfig=function(){return R.getConfig().getOptionsLiteral()},l.reset=function(){R=R.reset()},l.getBuildInfo=function(){return R.getBuildInfo()},l.getStats=function(){return R.getLoaderEvents()},l.define=S;function M(){if(typeof U.global.require!="undefined"||typeof require!="undefined"){var _=U.global.require||require;if(typeof _=="function"&&typeof _.resolve=="function"){var u=U.ensureRecordedNodeRequire(R.getRecorder(),_);U.global.nodeRequire=u,l.nodeRequire=u,l.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?(module.exports=l,require=l):(t.isElectronRenderer||(U.global.define=S),U.global.require=l)}U.init=M,(typeof U.global.define!="function"||!U.global.define.amd)&&(R=new U.ModuleManager(t,U.createScriptLoader(t),S,l,U.Utilities.getHighPerformanceTimestamp()),typeof U.global.require!="undefined"&&typeof U.global.require!="function"&&l.config(U.global.require),J=function(){return S.apply(null,arguments)},J.amd=S.amd,typeof doNotInitLoader=="undefined"&&M())})(ce||(ce={}));var Ie=this,Pe;(function(U){var t=Ie||{},R=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,S=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function D(f,b){var A;return b.length===0?A=f:A=f.replace(/\{(\d+)\}/g,function(v,m){var e=m[0];return typeof b[e]!="undefined"?b[e]:v}),S&&(A="\uFF3B"+A.replace(/[aouei]/g,"$&$&")+"\uFF3D"),A}function l(f,b){var A=f[b];return A||(A=f["*"],A)?A:null}function M(f,b){for(var A=[],v=0;v<arguments.length-2;v++)A[v]=arguments[v+2];return D(b,A)}function _(f){return function(b,A){var v=Array.prototype.slice.call(arguments,2);return D(f[b],v)}}var u=function(){function f(){this.localize=M}return f.prototype.setPseudoTranslation=function(b){S=b},f.prototype.create=function(b,A){return{localize:_(A[b])}},f.prototype.load=function(b,A,v,m){if(m=m||{},!b||b.length===0)v({localize:M});else{var e=void 0;if(R&&R.getString)e=".nls.keys",A([b+e],function(L){v({localize:function(w,s){if(!L[w])return"NLS error: unknown key "+w;var i=L[w].keys;if(s>=i.length)return"NLS error unknown index "+s;var r=i[s],a=[];a[0]=w+"_"+r;for(var d=0;d<arguments.length-2;d++)a[d+1]=arguments[d+2];return R.getString.apply(R,a)}})});else if(m.isBuild)A([b+".nls",b+".nls.keys"],function(L,w){f.BUILD_MAP[b]=L,f.BUILD_MAP_KEYS[b]=w,v(L)});else{var g=m["vs/nls"]||{},N=g.availableLanguages?l(g.availableLanguages,b):null;e=".nls",N!==null&&N!==f.DEFAULT_TAG&&(e=e+"."+N),A([b+e],function(L){Array.isArray(L)?L.localize=_(L):L.localize=_(L[b]),v(L)})}}},f.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},f.prototype.write=function(b,A,v){var m=v.getEntryPoint(),e=this._getEntryPointsMap();e[m]=e[m]||[],e[m].push(A),A!==m&&v.asModule(b+"!"+A,"define(['vs/nls', 'vs/nls!"+m+`'], function(nls, data) { return nls.create("`+A+'", data); });')},f.prototype.writeFile=function(b,A,v,m,e){var g=this._getEntryPointsMap();if(g.hasOwnProperty(A)){for(var N=v.toUrl(A+".nls.js"),L=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],w=g[A],s={},i=0;i<w.length;i++)s[w[i]]=f.BUILD_MAP[w[i]];L.push('define("'+A+'.nls", '+JSON.stringify(s,null,"	")+");"),m(N,L.join(`\r
`))}},f.prototype.finishBuild=function(b){b("nls.metadata.json",JSON.stringify({keys:f.BUILD_MAP_KEYS,messages:f.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},f.DEFAULT_TAG="i-default",f.BUILD_MAP={},f.BUILD_MAP_KEYS={},f}();U.NLSPlugin=u,function(){J("vs/nls",new u)}()})(Pe||(Pe={})),J(K[16],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class R{constructor(D,l,M,_){this.originalStart=D,this.originalLength=l,this.modifiedStart=M,this.modifiedLength=_}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=R}),J(K[7],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(d=>{d(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}t.ErrorHandler=R,t.errorHandler=new R;function S(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=S;function D(r){u(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=D;function l(r){u(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=l;function M(r){if(r instanceof Error){let{name:a,message:d}=r;const h=r.stacktrace||r.stack;return{$isError:!0,name:a,message:d,stack:h}}return r}t.transformErrorForSerialization=M;const _="Canceled";function u(r){return r instanceof Error&&r.name===_&&r.message===_}t.isPromiseCanceledError=u;class f extends Error{constructor(){super(_);this.name=this.message}}t.CancellationError=f;function b(){const r=new Error(_);return r.name=r.message,r}t.canceled=b;function A(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=A;function v(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=v;function m(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=m;function e(r){const a=new Error(`${r} has been disposed`);return a.name="DISPOSED",a}t.disposed=e;function g(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=g;class N extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}t.NotImplementedError=N;class L extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}t.NotSupportedError=L;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=w;function s(r){const a=r;return a instanceof Error&&Array.isArray(a.actions)}t.isErrorWithActions=s;function i(r,a=Object.create(null)){const d=new Error(r);return a.actions&&(d.actions=a.actions),d}t.createErrorWithActions=i}),J(K[17],x([0,1,7]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.compareBy=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function S(T,B=0){return T[T.length-(1+B)]}t.tail=S;function D(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=D;function l(T,B,O=(V,j)=>V===j){if(T===B)return!0;if(!T||!B||T.length!==B.length)return!1;for(let V=0,j=T.length;V<j;V++)if(!O(T[V],B[V]))return!1;return!0}t.equals=l;function M(T,B,O){let V=0,j=T.length-1;for(;V<=j;){const ee=(V+j)/2|0,te=O(T[ee],B);if(te<0)V=ee+1;else if(te>0)j=ee-1;else return ee}return-(V+1)}t.binarySearch=M;function _(T,B){let O=0,V=T.length;if(V===0)return 0;for(;O<V;){const j=Math.floor((O+V)/2);B(T[j])?V=j:O=j+1}return O}t.findFirstInSorted=_;function u(T,B,O){if(T=T|0,T>=B.length)throw new TypeError("invalid index");let V=B[Math.floor(B.length*Math.random())],j=[],ee=[],te=[];for(let de of B){const ge=O(de,V);ge<0?j.push(de):ge>0?ee.push(de):te.push(de)}return T<j.length?u(T,j,O):T<j.length+te.length?te[0]:u(T-(j.length+te.length),ee,O)}t.quickSelect=u;function f(T,B){const O=[];let V;for(const j of T.slice(0).sort(B))!V||B(V[0],j)!==0?(V=[j],O.push(V)):V.push(j);return O}t.groupBy=f;function b(T,B,O){const V=[];function j(de,ge,me){if(ge===0&&me.length===0)return;const ve=V[V.length-1];ve&&ve.start+ve.deleteCount===de?(ve.deleteCount+=ge,ve.toInsert.push(...me)):V.push({start:de,deleteCount:ge,toInsert:me})}let ee=0,te=0;for(;;){if(ee===T.length){j(ee,0,B.slice(te));break}if(te===B.length){j(ee,T.length-ee,[]);break}const de=T[ee],ge=B[te],me=O(de,ge);me===0?(ee+=1,te+=1):me<0?(j(ee,1,[]),ee+=1):me>0&&(j(ee,0,[ge]),te+=1)}return V}t.sortedDiff=b;function A(T,B,O){const V=b(T,B,O),j=[],ee=[];for(const te of V)j.push(...T.slice(te.start,te.start+te.deleteCount)),ee.push(...te.toInsert);return{removed:j,added:ee}}t.delta=A;function v(T,B,O){if(O===0)return[];const V=T.slice(0,O).sort(B);return e(T,B,V,O,T.length),V}t.top=v;function m(T,B,O,V,j){return O===0?Promise.resolve([]):new Promise((ee,te)=>{(async()=>{const de=T.length,ge=T.slice(0,O).sort(B);for(let me=O,ve=Math.min(O+V,de);me<de;me=ve,ve=Math.min(ve+V,de)){if(me>O&&await new Promise(pe=>setTimeout(pe)),j&&j.isCancellationRequested)throw(0,R.canceled)();e(T,B,ge,me,ve)}return ge})().then(ee,te)})}t.topAsync=m;function e(T,B,O,V,j){for(const ee=O.length;V<j;V++){const te=T[V];if(B(te,O[ee-1])<0){O.pop();const de=_(O,ge=>B(te,ge)<0);O.splice(de,0,te)}}}function g(T){return T.filter(B=>!!B)}t.coalesce=g;function N(T){let B=0;for(let O=0;O<T.length;O++)T[O]&&(T[B]=T[O],B+=1);T.length=B}t.coalesceInPlace=N;function L(T,B,O){T.splice(O,0,T.splice(B,1)[0])}t.move=L;function w(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=w;function s(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=s;function i(T,B=O=>O){const O=new Set;return T.filter(V=>{const j=B(V);return O.has(j)?!1:(O.add(j),!0)})}t.distinct=i;function r(T){const B=Object.create(null);return O=>{const V=T(O);return B[V]?!1:(B[V]=!0,!0)}}t.uniqueFilter=r;function a(T,B){const O=d(T,B);if(O!==-1)return T[O]}t.findLast=a;function d(T,B){for(let O=T.length-1;O>=0;O--){const V=T[O];if(B(V))return O}return-1}t.lastIndex=d;function h(T,B){return T.length>0?T[0]:B}t.firstOrDefault=h;function o(T,B,O=(V,j)=>V===j){let V=0;for(let j=0,ee=Math.min(T.length,B.length);j<ee&&O(T[j],B[j]);j++)V++;return V}t.commonPrefixLength=o;function c(T){return[].concat(...T)}t.flatten=c;function E(T,B){let O=typeof B=="number"?T:0;typeof B=="number"?O=T:(O=0,B=T);const V=[];if(O<=B)for(let j=O;j<B;j++)V.push(j);else for(let j=O;j>B;j--)V.push(j);return V}t.range=E;function P(T,B,O){return T.reduce((V,j)=>(V[B(j)]=O?O(j):j,V),Object.create(null))}t.index=P;function F(T,B){return T.push(B),()=>I(T,B)}t.insert=F;function I(T,B){const O=T.indexOf(B);if(O>-1)return T.splice(O,1),B}t.remove=I;function k(T,B,O){const V=T.slice(0,B),j=T.slice(B);return V.concat(O,j)}t.arrayInsert=k;function W(T,B){let O;if(typeof B=="number"){let V=B;O=()=>{const j=Math.sin(V++)*179426549;return j-Math.floor(j)}}else O=Math.random;for(let V=T.length-1;V>0;V-=1){const j=Math.floor(O()*(V+1)),ee=T[V];T[V]=T[j],T[j]=ee}}t.shuffle=W;function q(T,B){const O=T.indexOf(B);O>-1&&(T.splice(O,1),T.unshift(B))}t.pushToStart=q;function Q(T,B){const O=T.indexOf(B);O>-1&&(T.splice(O,1),T.push(B))}t.pushToEnd=Q;function G(T,B){return Array.isArray(T)?T.map(B):B(T)}t.mapArrayOrNot=G;function ue(T){return Array.isArray(T)?T:[T]}t.asArray=ue;function n(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=n;function ne(T,B){for(const O of T){const V=B(O);if(V!==void 0)return V}}t.mapFind=ne;function H(T,B,O){const V=Z(T,B),j=T.length,ee=O.length;T.length=j+ee;for(let te=j-1;te>=V;te--)T[te+ee]=T[te];for(let te=0;te<ee;te++)T[te+V]=O[te]}t.insertInto=H;function $(T,B,O,V){const j=Z(T,B),ee=T.splice(j,O);return H(T,j,V),ee}t.splice=$;function Z(T,B){return B<0?Math.max(B+T.length,0):Math.min(B,T.length)}function X(T,B){return(O,V)=>B(T(O),T(V))}t.compareBy=X;const ie=(T,B)=>T-B;t.numberComparator=ie;function re(T,B){if(T.length===0)return;let O=T[0];for(let V=1;V<T.length;V++){const j=T[V];B(j,O)>0&&(O=j)}return O}t.findMaxBy=re;function le(T,B){if(T.length===0)return;let O=T[0];for(let V=1;V<T.length;V++){const j=T[V];B(j,O)>=0&&(O=j)}return O}t.findLastMaxBy=le;function fe(T,B){return re(T,(O,V)=>-B(O,V))}t.findMinBy=fe;class Ee{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let O=this.firstIdx;for(;O<this.items.length&&B(this.items[O]);)O++;const V=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,V}takeFromEndWhile(B){let O=this.lastIdx;for(;O>=0&&B(this.items[O]);)O--;const V=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,V}peek(){return this.items[this.firstIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}takeCount(B){const O=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,O}}t.ArrayQueue=Ee}),J(K[9],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function R(S){const D=this;let l=!1,M;return function(){return l||(l=!0,M=S.apply(D,arguments)),M}}t.once=R}),J(K[18],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var R;(function(S){function D(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}S.is=D;const l=Object.freeze([]);function M(){return l}S.empty=M;function*_(r){yield r}S.single=_;function u(r){return r||l}S.from=u;function f(r){return!r||r[Symbol.iterator]().next().done===!0}S.isEmpty=f;function b(r){return r[Symbol.iterator]().next().value}S.first=b;function A(r,a){for(const d of r)if(a(d))return!0;return!1}S.some=A;function v(r,a){for(const d of r)if(a(d))return d}S.find=v;function*m(r,a){for(const d of r)a(d)&&(yield d)}S.filter=m;function*e(r,a){let d=0;for(const h of r)yield a(h,d++)}S.map=e;function*g(...r){for(const a of r)for(const d of a)yield d}S.concat=g;function*N(r){for(const a of r)for(const d of a)yield d}S.concatNested=N;function L(r,a,d){let h=d;for(const o of r)h=a(h,o);return h}S.reduce=L;function*w(r,a,d=r.length){for(a<0&&(a+=r.length),d<0?d+=r.length:d>r.length&&(d=r.length);a<d;a++)yield r[a]}S.slice=w;function s(r,a=Number.POSITIVE_INFINITY){const d=[];if(a===0)return[d,r];const h=r[Symbol.iterator]();for(let o=0;o<a;o++){const c=h.next();if(c.done)return[d,S.empty()];d.push(c.value)}return[d,{[Symbol.iterator](){return h}}]}S.consume=s;function i(r,a,d=(h,o)=>h===o){const h=r[Symbol.iterator](),o=a[Symbol.iterator]();for(;;){const c=h.next(),E=o.next();if(c.done!==E.done)return!1;if(c.done)return!0;if(!d(c.value,E.value))return!1}}S.equals=i})(R=t.Iterable||(t.Iterable={}))}),J(K[19],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var R;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.MAX_VALUE=126]="MAX_VALUE"})(R=t.KeyCode||(t.KeyCode={}));var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(S=t.ScanCode||(t.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,N){this._keyCodeToStr[g]=N,this._strToKeyCode[N.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const l=new D,M=new D,_=new D;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const u=[],f=Object.create(null),b=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>b[e]||0,toEnum:e=>f[e]||0,toString:e=>u[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let N=[],L=[];for(const w of g){const[s,i,r,a,d,h,o,c,E,P]=w;if(L[r]||(L[r]=!0,u[r]=a,f[a]=r,b[a.toLowerCase()]=r,i&&(t.IMMUTABLE_CODE_TO_KEY_CODE[r]=d,d!==0&&d!==3&&d!==5&&d!==4&&d!==6&&d!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[d]=r))),!N[d]){if(N[d]=!0,!h)throw new Error(`String representation missing for key code ${d} around scan code ${a}`);l.define(d,h),M.define(d,E||h),_.define(d,P||E||h)}o&&(t.EVENT_KEY_CODE_MAP[o]=d),c&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[c]=d)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var A;(function(e){function g(r){return l.keyCodeToStr(r)}e.toString=g;function N(r){return l.strToKeyCode(r)}e.fromString=N;function L(r){return M.keyCodeToStr(r)}e.toUserSettingsUS=L;function w(r){return _.keyCodeToStr(r)}e.toUserSettingsGeneral=w;function s(r){return M.strToKeyCode(r)||_.strToKeyCode(r)}e.fromUserSettings=s;function i(r){if(r>=93&&r<=108)return null;switch(r){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return l.keyCodeToStr(r)}e.toElectronAccelerator=i})(A=t.KeyCodeUtils||(t.KeyCodeUtils={}));var v;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(v=t.KeyMod||(t.KeyMod={}));function m(e,g){const N=(g&65535)<<16>>>0;return(e|N)>>>0}t.KeyChord=m}),J(K[10],x([0,1,9,18]),function(U,t,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const D=!1;let l=null;function M(o){l=o}if(t.setDisposableTracker=M,D){const o="__is_disposable_tracked__";M(new class{trackDisposable(c){const E=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(E)},3e3)}setParent(c,E){if(c&&c!==w.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==w.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function _(o){return l?.trackDisposable(o),o}function u(o){l?.markAsDisposed(o)}function f(o,c){l?.setParent(o,c)}function b(o,c){if(!!l)for(const E of o)l.setParent(E,c)}function A(o){return l?.markAsSingleton(o),o}t.markAsSingleton=A;class v extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}t.MultiDisposeError=v;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}t.isDisposable=m;function e(o){if(S.Iterable.is(o)){let c=[];for(const E of o)if(E)try{E.dispose()}catch(P){c.push(P)}if(c.length===1)throw c[0];if(c.length>1)throw new v(c);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}t.dispose=e;function g(...o){const c=N(()=>e(o));return b(o,c),c}t.combinedDisposable=g;function N(o){const c=_({dispose:(0,R.once)(()=>{u(c),o()})});return c}t.toDisposable=N;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return f(c,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}t.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new L,_(this),f(this._store,this)}dispose(){u(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}t.Disposable=w,w.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&f(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&f(c,null),c}}t.MutableDisposable=s;class i{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=i;class r{constructor(){this.references=new Map}acquire(c,...E){let P=this.references.get(c);P||(P={counter:0,object:this.createReferencedObject(c,...E)},this.references.set(c,P));const{object:F}=P,I=(0,R.once)(()=>{--P.counter==0&&(this.destroyReferencedObject(c,P.object),this.references.delete(c))});return P.counter++,{object:F,dispose:I}}}t.ReferenceCollection=r;class a{constructor(c){this.referenceCollection=c}async acquire(c,...E){const P=this.referenceCollection.acquire(c,...E);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(F){throw P.dispose(),F}}}t.AsyncReferenceCollection=a;class d{constructor(c){this.object=c}dispose(){}}t.ImmortalReference=d;function h(o){const c=new L;try{o(c)}finally{c.dispose()}}t.disposeOnReturn=h}),J(K[20],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class R{constructor(l){this.element=l,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class S{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let l=this._first;for(;l!==R.Undefined;){const M=l.next;l.prev=R.Undefined,l.next=R.Undefined,l=M}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,M){const _=new R(l);if(this._first===R.Undefined)this._first=_,this._last=_;else if(M){const f=this._last;this._last=_,_.prev=f,f.next=_}else{const f=this._first;this._first=_,_.next=f,f.prev=_}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(_))}}shift(){if(this._first!==R.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==R.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==R.Undefined&&l.next!==R.Undefined){const M=l.prev;M.next=l.next,l.next.prev=M}else l.prev===R.Undefined&&l.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):l.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):l.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==R.Undefined;)yield l.element,l=l.next}}t.LinkedList=S}),J(K[2],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isElectronSandboxed=t.globals=void 0;const R="en";let S=!1,D=!1,l=!1,M=!1,_=!1,u=!1,f=!1,b=!1,A,v=R,m,e;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?g=t.globals.vscode.process:typeof process!="undefined"&&(g=process);const N=typeof g?.versions?.electron=="string",L=N&&g?.type==="renderer";if(t.isElectronSandboxed=L&&g?.sandboxed,typeof navigator=="object"&&!L)e=navigator.userAgent,S=e.indexOf("Windows")>=0,D=e.indexOf("Macintosh")>=0,b=(e.indexOf("Macintosh")>=0||e.indexOf("iPad")>=0||e.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=e.indexOf("Linux")>=0,u=!0,A=navigator.language,v=A;else if(typeof g=="object"){S=g.platform==="win32",D=g.platform==="darwin",l=g.platform==="linux",M=l&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,f=N,A=R,v=R;const c=g.env.VSCODE_NLS_CONFIG;if(c)try{const E=JSON.parse(c),P=E.availableLanguages["*"];A=E.locale,v=P||R,m=E._translationsConfigFile}catch(E){}_=!0}else console.error("Unable to resolve platform.");var w;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(w=t.Platform||(t.Platform={}));function s(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=s;let i=0;D?i=1:S?i=3:l&&(i=2),t.isWindows=S,t.isMacintosh=D,t.isLinux=l,t.isLinuxSnap=M,t.isNative=_,t.isElectron=f,t.isWeb=u,t.isIOS=b,t.platform=i,t.userAgent=e,t.language=v;var r;(function(c){function E(){return t.language}c.value=E;function P(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}c.isDefaultVariant=P;function F(){return t.language==="en"}c.isDefault=F})(r=t.Language||(t.Language={})),t.locale=A,t.translationsConfigFile=m,t.setTimeout0=(()=>{if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let c=[];t.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let F=0,I=c.length;F<I;F++){const k=c[F];if(k.id===P.data.vscodeScheduleAsyncWork){c.splice(F,1),k.callback();return}}});let E=0;return P=>{const F=++E;c.push({id:F,callback:P}),t.globals.postMessage({vscodeScheduleAsyncWork:F},"*")}}return c=>setTimeout(c)})();var a;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(a=t.OperatingSystem||(t.OperatingSystem={})),t.OS=D||b?2:S?1:3;let d=!0,h=!1;function o(){if(!h){h=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,d=new Uint16Array(c.buffer)[0]===(2<<8)+1}return d}t.isLittleEndian=o}),J(K[21],x([0,1,2]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let S;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;S={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=S.cwd,t.env=S.env,t.platform=S.platform,t.arch=S.arch}),J(K[22],x([0,1,21]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const S=65,D=97,l=90,M=122,_=46,u=47,f=92,b=58,A=63;class v extends Error{constructor(i,r,a){let d;typeof r=="string"&&r.indexOf("not ")===0?(d="must not be",r=r.replace(/^not /,"")):d="must be";const h=i.indexOf(".")!==-1?"property":"argument";let o=`The "${i}" ${h} ${d} of type ${r}`;o+=`. Received type ${typeof a}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function m(s,i){if(typeof s!="string")throw new v(i,"string",s)}function e(s){return s===u||s===f}function g(s){return s===u}function N(s){return s>=S&&s<=l||s>=D&&s<=M}function L(s,i,r,a){let d="",h=0,o=-1,c=0,E=0;for(let P=0;P<=s.length;++P){if(P<s.length)E=s.charCodeAt(P);else{if(a(E))break;E=u}if(a(E)){if(!(o===P-1||c===1))if(c===2){if(d.length<2||h!==2||d.charCodeAt(d.length-1)!==_||d.charCodeAt(d.length-2)!==_){if(d.length>2){const F=d.lastIndexOf(r);F===-1?(d="",h=0):(d=d.slice(0,F),h=d.length-1-d.lastIndexOf(r)),o=P,c=0;continue}else if(d.length!==0){d="",h=0,o=P,c=0;continue}}i&&(d+=d.length>0?`${r}..`:"..",h=2)}else d.length>0?d+=`${r}${s.slice(o+1,P)}`:d=s.slice(o+1,P),h=P-o-1;o=P,c=0}else E===_&&c!==-1?++c:c=-1}return d}function w(s,i){if(i===null||typeof i!="object")throw new v("pathObject","Object",i);const r=i.dir||i.root,a=i.base||`${i.name||""}${i.ext||""}`;return r?r===i.root?`${r}${a}`:`${r}${s}${a}`:a}t.win32={resolve(...s){let i="",r="",a=!1;for(let d=s.length-1;d>=-1;d--){let h;if(d>=0){if(h=s[d],m(h,"path"),h.length===0)continue}else i.length===0?h=R.cwd():(h=R.env[`=${i}`]||R.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==i.toLowerCase()&&h.charCodeAt(2)===f)&&(h=`${i}\\`));const o=h.length;let c=0,E="",P=!1;const F=h.charCodeAt(0);if(o===1)e(F)&&(c=1,P=!0);else if(e(F))if(P=!0,e(h.charCodeAt(1))){let I=2,k=I;for(;I<o&&!e(h.charCodeAt(I));)I++;if(I<o&&I!==k){const W=h.slice(k,I);for(k=I;I<o&&e(h.charCodeAt(I));)I++;if(I<o&&I!==k){for(k=I;I<o&&!e(h.charCodeAt(I));)I++;(I===o||I!==k)&&(E=`\\\\${W}\\${h.slice(k,I)}`,c=I)}}}else c=1;else N(F)&&h.charCodeAt(1)===b&&(E=h.slice(0,2),c=2,o>2&&e(h.charCodeAt(2))&&(P=!0,c=3));if(E.length>0)if(i.length>0){if(E.toLowerCase()!==i.toLowerCase())continue}else i=E;if(a){if(i.length>0)break}else if(r=`${h.slice(c)}\\${r}`,a=P,P&&i.length>0)break}return r=L(r,!a,"\\",e),a?`${i}\\${r}`:`${i}${r}`||"."},normalize(s){m(s,"path");const i=s.length;if(i===0)return".";let r=0,a,d=!1;const h=s.charCodeAt(0);if(i===1)return g(h)?"\\":s;if(e(h))if(d=!0,e(s.charCodeAt(1))){let c=2,E=c;for(;c<i&&!e(s.charCodeAt(c));)c++;if(c<i&&c!==E){const P=s.slice(E,c);for(E=c;c<i&&e(s.charCodeAt(c));)c++;if(c<i&&c!==E){for(E=c;c<i&&!e(s.charCodeAt(c));)c++;if(c===i)return`\\\\${P}\\${s.slice(E)}\\`;c!==E&&(a=`\\\\${P}\\${s.slice(E,c)}`,r=c)}}}else r=1;else N(h)&&s.charCodeAt(1)===b&&(a=s.slice(0,2),r=2,i>2&&e(s.charCodeAt(2))&&(d=!0,r=3));let o=r<i?L(s.slice(r),!d,"\\",e):"";return o.length===0&&!d&&(o="."),o.length>0&&e(s.charCodeAt(i-1))&&(o+="\\"),a===void 0?d?`\\${o}`:o:d?`${a}\\${o}`:`${a}${o}`},isAbsolute(s){m(s,"path");const i=s.length;if(i===0)return!1;const r=s.charCodeAt(0);return e(r)||i>2&&N(r)&&s.charCodeAt(1)===b&&e(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let i,r;for(let h=0;h<s.length;++h){const o=s[h];m(o,"path"),o.length>0&&(i===void 0?i=r=o:i+=`\\${o}`)}if(i===void 0)return".";let a=!0,d=0;if(typeof r=="string"&&e(r.charCodeAt(0))){++d;const h=r.length;h>1&&e(r.charCodeAt(1))&&(++d,h>2&&(e(r.charCodeAt(2))?++d:a=!1))}if(a){for(;d<i.length&&e(i.charCodeAt(d));)d++;d>=2&&(i=`\\${i.slice(d)}`)}return t.win32.normalize(i)},relative(s,i){if(m(s,"from"),m(i,"to"),s===i)return"";const r=t.win32.resolve(s),a=t.win32.resolve(i);if(r===a||(s=r.toLowerCase(),i=a.toLowerCase(),s===i))return"";let d=0;for(;d<s.length&&s.charCodeAt(d)===f;)d++;let h=s.length;for(;h-1>d&&s.charCodeAt(h-1)===f;)h--;const o=h-d;let c=0;for(;c<i.length&&i.charCodeAt(c)===f;)c++;let E=i.length;for(;E-1>c&&i.charCodeAt(E-1)===f;)E--;const P=E-c,F=o<P?o:P;let I=-1,k=0;for(;k<F;k++){const q=s.charCodeAt(d+k);if(q!==i.charCodeAt(c+k))break;q===f&&(I=k)}if(k!==F){if(I===-1)return a}else{if(P>F){if(i.charCodeAt(c+k)===f)return a.slice(c+k+1);if(k===2)return a.slice(c+k)}o>F&&(s.charCodeAt(d+k)===f?I=k:k===2&&(I=3)),I===-1&&(I=0)}let W="";for(k=d+I+1;k<=h;++k)(k===h||s.charCodeAt(k)===f)&&(W+=W.length===0?"..":"\\..");return c+=I,W.length>0?`${W}${a.slice(c,E)}`:(a.charCodeAt(c)===f&&++c,a.slice(c,E))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const i=t.win32.resolve(s);if(i.length<=2)return s;if(i.charCodeAt(0)===f){if(i.charCodeAt(1)===f){const r=i.charCodeAt(2);if(r!==A&&r!==_)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(N(i.charCodeAt(0))&&i.charCodeAt(1)===b&&i.charCodeAt(2)===f)return`\\\\?\\${i}`;return s},dirname(s){m(s,"path");const i=s.length;if(i===0)return".";let r=-1,a=0;const d=s.charCodeAt(0);if(i===1)return e(d)?s:".";if(e(d)){if(r=a=1,e(s.charCodeAt(1))){let c=2,E=c;for(;c<i&&!e(s.charCodeAt(c));)c++;if(c<i&&c!==E){for(E=c;c<i&&e(s.charCodeAt(c));)c++;if(c<i&&c!==E){for(E=c;c<i&&!e(s.charCodeAt(c));)c++;if(c===i)return s;c!==E&&(r=a=c+1)}}}}else N(d)&&s.charCodeAt(1)===b&&(r=i>2&&e(s.charCodeAt(2))?3:2,a=r);let h=-1,o=!0;for(let c=i-1;c>=a;--c)if(e(s.charCodeAt(c))){if(!o){h=c;break}}else o=!1;if(h===-1){if(r===-1)return".";h=r}return s.slice(0,h)},basename(s,i){i!==void 0&&m(i,"ext"),m(s,"path");let r=0,a=-1,d=!0,h;if(s.length>=2&&N(s.charCodeAt(0))&&s.charCodeAt(1)===b&&(r=2),i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let o=i.length-1,c=-1;for(h=s.length-1;h>=r;--h){const E=s.charCodeAt(h);if(e(E)){if(!d){r=h+1;break}}else c===-1&&(d=!1,c=h+1),o>=0&&(E===i.charCodeAt(o)?--o==-1&&(a=h):(o=-1,a=c))}return r===a?a=c:a===-1&&(a=s.length),s.slice(r,a)}for(h=s.length-1;h>=r;--h)if(e(s.charCodeAt(h))){if(!d){r=h+1;break}}else a===-1&&(d=!1,a=h+1);return a===-1?"":s.slice(r,a)},extname(s){m(s,"path");let i=0,r=-1,a=0,d=-1,h=!0,o=0;s.length>=2&&s.charCodeAt(1)===b&&N(s.charCodeAt(0))&&(i=a=2);for(let c=s.length-1;c>=i;--c){const E=s.charCodeAt(c);if(e(E)){if(!h){a=c+1;break}continue}d===-1&&(h=!1,d=c+1),E===_?r===-1?r=c:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||d===-1||o===0||o===1&&r===d-1&&r===a+1?"":s.slice(r,d)},format:w.bind(null,"\\"),parse(s){m(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const r=s.length;let a=0,d=s.charCodeAt(0);if(r===1)return e(d)?(i.root=i.dir=s,i):(i.base=i.name=s,i);if(e(d)){if(a=1,e(s.charCodeAt(1))){let I=2,k=I;for(;I<r&&!e(s.charCodeAt(I));)I++;if(I<r&&I!==k){for(k=I;I<r&&e(s.charCodeAt(I));)I++;if(I<r&&I!==k){for(k=I;I<r&&!e(s.charCodeAt(I));)I++;I===r?a=I:I!==k&&(a=I+1)}}}}else if(N(d)&&s.charCodeAt(1)===b){if(r<=2)return i.root=i.dir=s,i;if(a=2,e(s.charCodeAt(2))){if(r===3)return i.root=i.dir=s,i;a=3}}a>0&&(i.root=s.slice(0,a));let h=-1,o=a,c=-1,E=!0,P=s.length-1,F=0;for(;P>=a;--P){if(d=s.charCodeAt(P),e(d)){if(!E){o=P+1;break}continue}c===-1&&(E=!1,c=P+1),d===_?h===-1?h=P:F!==1&&(F=1):h!==-1&&(F=-1)}return c!==-1&&(h===-1||F===0||F===1&&h===c-1&&h===o+1?i.base=i.name=s.slice(o,c):(i.name=s.slice(o,h),i.base=s.slice(o,c),i.ext=s.slice(h,c))),o>0&&o!==a?i.dir=s.slice(0,o-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...s){let i="",r=!1;for(let a=s.length-1;a>=-1&&!r;a--){const d=a>=0?s[a]:R.cwd();m(d,"path"),d.length!==0&&(i=`${d}/${i}`,r=d.charCodeAt(0)===u)}return i=L(i,!r,"/",g),r?`/${i}`:i.length>0?i:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===u,r=s.charCodeAt(s.length-1)===u;return s=L(s,!i,"/",g),s.length===0?i?"/":r?"./":".":(r&&(s+="/"),i?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===u},join(...s){if(s.length===0)return".";let i;for(let r=0;r<s.length;++r){const a=s[r];m(a,"path"),a.length>0&&(i===void 0?i=a:i+=`/${a}`)}return i===void 0?".":t.posix.normalize(i)},relative(s,i){if(m(s,"from"),m(i,"to"),s===i||(s=t.posix.resolve(s),i=t.posix.resolve(i),s===i))return"";const r=1,a=s.length,d=a-r,h=1,o=i.length-h,c=d<o?d:o;let E=-1,P=0;for(;P<c;P++){const I=s.charCodeAt(r+P);if(I!==i.charCodeAt(h+P))break;I===u&&(E=P)}if(P===c)if(o>c){if(i.charCodeAt(h+P)===u)return i.slice(h+P+1);if(P===0)return i.slice(h+P)}else d>c&&(s.charCodeAt(r+P)===u?E=P:P===0&&(E=0));let F="";for(P=r+E+1;P<=a;++P)(P===a||s.charCodeAt(P)===u)&&(F+=F.length===0?"..":"/..");return`${F}${i.slice(h+E)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===u;let r=-1,a=!0;for(let d=s.length-1;d>=1;--d)if(s.charCodeAt(d)===u){if(!a){r=d;break}}else a=!1;return r===-1?i?"/":".":i&&r===1?"//":s.slice(0,r)},basename(s,i){i!==void 0&&m(i,"ext"),m(s,"path");let r=0,a=-1,d=!0,h;if(i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let o=i.length-1,c=-1;for(h=s.length-1;h>=0;--h){const E=s.charCodeAt(h);if(E===u){if(!d){r=h+1;break}}else c===-1&&(d=!1,c=h+1),o>=0&&(E===i.charCodeAt(o)?--o==-1&&(a=h):(o=-1,a=c))}return r===a?a=c:a===-1&&(a=s.length),s.slice(r,a)}for(h=s.length-1;h>=0;--h)if(s.charCodeAt(h)===u){if(!d){r=h+1;break}}else a===-1&&(d=!1,a=h+1);return a===-1?"":s.slice(r,a)},extname(s){m(s,"path");let i=-1,r=0,a=-1,d=!0,h=0;for(let o=s.length-1;o>=0;--o){const c=s.charCodeAt(o);if(c===u){if(!d){r=o+1;break}continue}a===-1&&(d=!1,a=o+1),c===_?i===-1?i=o:h!==1&&(h=1):i!==-1&&(h=-1)}return i===-1||a===-1||h===0||h===1&&i===a-1&&i===r+1?"":s.slice(i,a)},format:w.bind(null,"/"),parse(s){m(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const r=s.charCodeAt(0)===u;let a;r?(i.root="/",a=1):a=0;let d=-1,h=0,o=-1,c=!0,E=s.length-1,P=0;for(;E>=a;--E){const F=s.charCodeAt(E);if(F===u){if(!c){h=E+1;break}continue}o===-1&&(c=!1,o=E+1),F===_?d===-1?d=E:P!==1&&(P=1):d!==-1&&(P=-1)}if(o!==-1){const F=h===0&&r?1:h;d===-1||P===0||P===1&&d===o-1&&d===h+1?i.base=i.name=s.slice(F,o):(i.name=s.slice(F,d),i.base=s.slice(F,o),i.ext=s.slice(d,o))}return h>0?i.dir=s.slice(0,h-1):r&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=R.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=R.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=R.platform==="win32"?t.win32.join:t.posix.join,t.resolve=R.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=R.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=R.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=R.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=R.platform==="win32"?t.win32.extname:t.posix.extname,t.format=R.platform==="win32"?t.win32.format:t.posix.format,t.parse=R.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=R.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=R.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=R.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),J(K[11],x([0,1,2]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const S=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(M){this._highResolution=S&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new D(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}t.StopWatch=D}),J(K[8],x([0,1,7,9,10,20,11]),function(U,t,R,S,D,l,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var _;(function(i){i.None=()=>D.Disposable.None;function r(H){return($,Z=null,X)=>{let ie=!1,re;return re=H(le=>{if(!ie)return re?re.dispose():ie=!0,$.call(Z,le)},null,X),ie&&re.dispose(),re}}i.once=r;function a(H,$){return P((Z,X=null,ie)=>H(re=>Z.call(X,$(re)),null,ie))}i.map=a;function d(H,$){return P((Z,X=null,ie)=>H(re=>{$(re),Z.call(X,re)},null,ie))}i.forEach=d;function h(H,$){return P((Z,X=null,ie)=>H(re=>$(re)&&Z.call(X,re),null,ie))}i.filter=h;function o(H){return H}i.signal=o;function c(...H){return($,Z=null,X)=>(0,D.combinedDisposable)(...H.map(ie=>ie(re=>$.call(Z,re),null,X)))}i.any=c;function E(H,$,Z){let X=Z;return a(H,ie=>(X=$(X,ie),X))}i.reduce=E;function P(H){let $;const Z=new v({onFirstListenerAdd(){$=H(Z.fire,Z)},onLastListenerRemove(){$.dispose()}});return Z.event}function F(H,$,Z=100,X=!1,ie){let re,le,fe,Ee=0;const T=new v({leakWarningThreshold:ie,onFirstListenerAdd(){re=H(B=>{Ee++,le=$(le,B),X&&!fe&&(T.fire(le),le=void 0),clearTimeout(fe),fe=setTimeout(()=>{const O=le;le=void 0,fe=void 0,(!X||Ee>1)&&T.fire(O),Ee=0},Z)})},onLastListenerRemove(){re.dispose()}});return T.event}i.debounce=F;function I(H,$=(Z,X)=>Z===X){let Z=!0,X;return h(H,ie=>{const re=Z||!$(ie,X);return Z=!1,X=ie,re})}i.latch=I;function k(H,$){return[i.filter(H,$),i.filter(H,Z=>!$(Z))]}i.split=k;function W(H,$=!1,Z=[]){let X=Z.slice(),ie=H(fe=>{X?X.push(fe):le.fire(fe)});const re=()=>{X&&X.forEach(fe=>le.fire(fe)),X=null},le=new v({onFirstListenerAdd(){ie||(ie=H(fe=>le.fire(fe)))},onFirstListenerDidAdd(){X&&($?setTimeout(re):re())},onLastListenerRemove(){ie&&ie.dispose(),ie=null}});return le.event}i.buffer=W;class q{constructor($){this.event=$}map($){return new q(a(this.event,$))}forEach($){return new q(d(this.event,$))}filter($){return new q(h(this.event,$))}reduce($,Z){return new q(E(this.event,$,Z))}latch(){return new q(I(this.event))}debounce($,Z=100,X=!1,ie){return new q(F(this.event,$,Z,X,ie))}on($,Z,X){return this.event($,Z,X)}once($,Z,X){return r(this.event)($,Z,X)}}function Q(H){return new q(H)}i.chain=Q;function G(H,$,Z=X=>X){const X=(...fe)=>le.fire(Z(...fe)),ie=()=>H.on($,X),re=()=>H.removeListener($,X),le=new v({onFirstListenerAdd:ie,onLastListenerRemove:re});return le.event}i.fromNodeEventEmitter=G;function ue(H,$,Z=X=>X){const X=(...fe)=>le.fire(Z(...fe)),ie=()=>H.addEventListener($,X),re=()=>H.removeEventListener($,X),le=new v({onFirstListenerAdd:ie,onLastListenerRemove:re});return le.event}i.fromDOMEventEmitter=ue;function n(H){return new Promise($=>r(H)($))}i.toPromise=n;function ne(H,$){return $(void 0),H(Z=>$(Z))}i.runAndSubscribe=ne})(_=t.Event||(t.Event={}));class u{constructor(r){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${r}_${u._idPool++}`}start(r){this._stopWatch=new M.StopWatch(!0),this._listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this._elapsedOverall+=r,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${r.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let f=-1;function b(i){const r=f;return f=i,{dispose(){f=r}}}t.setGlobalLeakWarningThreshold=b;class A{constructor(r,a=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r){let a=f;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||r<a)return;this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(d)||0;if(this._stacks.set(d,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let o,c=0;for(const[E,P]of this._stacks)(!o||c<P)&&(o=E,c=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${c}):`),console.warn(o)}return()=>{const o=this._stacks.get(d)||0;this._stacks.set(d,o-1)}}}class v{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=f>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(r,a,d)=>{this._listeners||(this._listeners=new l.LinkedList);const h=this._listeners.isEmpty();h&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(a?[r,a]:r);h&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,a);const c=this._leakageMon?.check(this._listeners.size),E=(0,D.toDisposable)(()=>{c&&c(),this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return d instanceof D.DisposableStore?d.add(E):Array.isArray(d)&&d.push(E),E}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new l.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,r]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,d]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,d):a[0].call(a[1],d)}catch(h){(0,R.onUnexpectedError)(h)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}t.Emitter=v;class m extends v{async fireAsync(r,a,d){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new l.LinkedList);for(const h of this._listeners)this._asyncDeliveryQueue.push([h,r]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[h,o]=this._asyncDeliveryQueue.shift(),c=[],E={...o,token:a,waitUntil:P=>{if(Object.isFrozen(c))throw new Error("waitUntil can NOT be called asynchronous");d&&(P=d(P,typeof h=="function"?h:h[0])),c.push(P)}};try{typeof h=="function"?h.call(void 0,E):h[0].call(h[1],E)}catch(P){(0,R.onUnexpectedError)(P);continue}Object.freeze(c),await Promise.allSettled(c).then(P=>{for(const F of P)F.status==="rejected"&&(0,R.onUnexpectedError)(F.reason)})}}}}t.AsyncEmitter=m;class e extends v{constructor(r){super(r);this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}t.PauseableEmitter=e;class g extends e{constructor(r){super(r);this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}t.DebounceEmitter=g;class N extends v{constructor(r){super(r);this._queuedEvents=[],this._mergeFn=r?.merge}fire(r){this._queuedEvents.push(r),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]})}}t.MicrotaskEmitter=N;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const a={event:r,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const d=()=>{this.hasListeners&&this.unhook(a);const h=this.events.indexOf(a);this.events.splice(h,1)};return(0,D.toDisposable)((0,S.once)(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(a=>this.emitter.fire(a))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=L;class w{constructor(){this.buffers=[]}wrapEvent(r){return(a,d,h)=>r(o=>{const c=this.buffers[this.buffers.length-1];c?c.push(()=>a.call(d,o)):a.call(d,o)},void 0,h)}bufferEvents(r){const a=[];this.buffers.push(a);const d=r();return this.buffers.pop(),a.forEach(h=>h()),d}}t.EventBufferer=w;class s{constructor(){this.listening=!1,this.inputEvent=_.None,this.inputEventListener=D.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=s}),J(K[23],x([0,1,8]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const S=Object.freeze(function(_,u){const f=setTimeout(_.bind(u),0);return{dispose(){clearTimeout(f)}}});var D;(function(_){function u(f){return f===_.None||f===_.Cancelled||f instanceof l?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}_.isCancellationToken=u,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(D=t.CancellationToken||(t.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?S:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=D.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=D.None}}t.CancellationTokenSource=M}),J(K[3],x([0,1,2]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function S(p){return!p||typeof p!="string"?!0:p.trim().length===0}t.isFalsyOrWhitespace=S;const D=/{(\d+)}/g;function l(p,...y){return y.length===0?p:p.replace(D,function(C,z){const Y=parseInt(z,10);return isNaN(Y)||Y<0||Y>=y.length?C:y[Y]})}t.format=l;const M=/{([^}]+)}/g;function _(p,y){return p.replace(M,(C,z)=>y[z]??C)}t.format2=_;function u(p){return p.replace(/[<>&]/g,function(y){switch(y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return y}})}t.escape=u;function f(p){return p.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=f;function b(p,y){let C=0;const z=y.charCodeAt(0);for(let Y=p.length-1;Y>=0;Y--)p.charCodeAt(Y)===z&&C++;return C}t.count=b;function A(p,y,C="\u2026"){return p.length<=y?p:`${p.substr(0,y)}${C}`}t.truncate=A;function v(p,y=" "){const C=m(p,y);return e(C,y)}t.trim=v;function m(p,y){if(!p||!y)return p;const C=y.length;if(C===0||p.length===0)return p;let z=0;for(;p.indexOf(y,z)===z;)z=z+C;return p.substring(z)}t.ltrim=m;function e(p,y){if(!p||!y)return p;const C=y.length,z=p.length;if(C===0||z===0)return p;let Y=z,se=-1;for(;se=p.lastIndexOf(y,Y-1),!(se===-1||se+C!==Y);){if(se===0)return"";Y=se}return p.substring(0,Y)}t.rtrim=e;function g(p){return p.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=g;function N(p){return p.replace(/\*/g,"")}t.stripWildcards=N;function L(p,y,C={}){if(!p)throw new Error("Cannot create regex from empty string");y||(p=f(p)),C.wholeWord&&(/\B/.test(p.charAt(0))||(p="\\b"+p),/\B/.test(p.charAt(p.length-1))||(p=p+"\\b"));let z="";return C.global&&(z+="g"),C.matchCase||(z+="i"),C.multiline&&(z+="m"),C.unicode&&(z+="u"),new RegExp(p,z)}t.createRegExp=L;function w(p){return p.source==="^"||p.source==="^$"||p.source==="$"||p.source==="^\\s*$"?!1:!!(p.exec("")&&p.lastIndex===0)}t.regExpLeadsToEndlessLoop=w;function s(p){return!!p.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=s;function i(p){return(p.global?"g":"")+(p.ignoreCase?"i":"")+(p.multiline?"m":"")+(p.unicode?"u":"")}t.regExpFlags=i;function r(p){return p.split(/\r\n|\r|\n/)}t.splitLines=r;function a(p){for(let y=0,C=p.length;y<C;y++){const z=p.charCodeAt(y);if(z!==32&&z!==9)return y}return-1}t.firstNonWhitespaceIndex=a;function d(p,y=0,C=p.length){for(let z=y;z<C;z++){const Y=p.charCodeAt(z);if(Y!==32&&Y!==9)return p.substring(y,z)}return p.substring(y,C)}t.getLeadingWhitespace=d;function h(p,y=p.length-1){for(let C=y;C>=0;C--){const z=p.charCodeAt(C);if(z!==32&&z!==9)return C}return-1}t.lastNonWhitespaceIndex=h;function o(p,y){return p<y?-1:p>y?1:0}t.compare=o;function c(p,y,C=0,z=p.length,Y=0,se=y.length){for(;C<z&&Y<se;C++,Y++){let he=p.charCodeAt(C),_e=y.charCodeAt(Y);if(he<_e)return-1;if(he>_e)return 1}const ae=z-C,oe=se-Y;return ae<oe?-1:ae>oe?1:0}t.compareSubstring=c;function E(p,y){return P(p,y,0,p.length,0,y.length)}t.compareIgnoreCase=E;function P(p,y,C=0,z=p.length,Y=0,se=y.length){for(;C<z&&Y<se;C++,Y++){let he=p.charCodeAt(C),_e=y.charCodeAt(Y);if(he===_e)continue;if(he>=128||_e>=128)return c(p.toLowerCase(),y.toLowerCase(),C,z,Y,se);F(he)&&(he-=32),F(_e)&&(_e-=32);const be=he-_e;if(be!==0)return be}const ae=z-C,oe=se-Y;return ae<oe?-1:ae>oe?1:0}t.compareSubstringIgnoreCase=P;function F(p){return p>=97&&p<=122}t.isLowerAsciiLetter=F;function I(p){return p>=65&&p<=90}t.isUpperAsciiLetter=I;function k(p,y){return p.length===y.length&&P(p,y)===0}t.equalsIgnoreCase=k;function W(p,y){const C=y.length;return y.length>p.length?!1:P(p,y,0,C)===0}t.startsWithIgnoreCase=W;function q(p,y){let C,z=Math.min(p.length,y.length);for(C=0;C<z;C++)if(p.charCodeAt(C)!==y.charCodeAt(C))return C;return z}t.commonPrefixLength=q;function Q(p,y){let C,z=Math.min(p.length,y.length);const Y=p.length-1,se=y.length-1;for(C=0;C<z;C++)if(p.charCodeAt(Y-C)!==y.charCodeAt(se-C))return C;return z}t.commonSuffixLength=Q;function G(p){return 55296<=p&&p<=56319}t.isHighSurrogate=G;function ue(p){return 56320<=p&&p<=57343}t.isLowSurrogate=ue;function n(p,y){return(p-55296<<10)+(y-56320)+65536}t.computeCodePoint=n;function ne(p,y,C){const z=p.charCodeAt(C);if(G(z)&&C+1<y){const Y=p.charCodeAt(C+1);if(ue(Y))return n(z,Y)}return z}t.getNextCodePoint=ne;function H(p,y){const C=p.charCodeAt(y-1);if(ue(C)&&y>1){const z=p.charCodeAt(y-2);if(G(z))return n(z,C)}return C}function $(p,y){const C=Le.getInstance(),z=y,Y=p.length,se=ne(p,Y,y);y+=se>=65536?2:1;let ae=C.getGraphemeBreakType(se);for(;y<Y;){const oe=ne(p,Y,y),he=C.getGraphemeBreakType(oe);if(Ae(ae,he))break;y+=oe>=65536?2:1,ae=he}return y-z}t.nextCharLength=$;function Z(p,y){const C=Le.getInstance(),z=y,Y=H(p,y);y-=Y>=65536?2:1;let se=C.getGraphemeBreakType(Y);for(;y>0;){const ae=H(p,y),oe=C.getGraphemeBreakType(ae);if(Ae(oe,se))break;y-=ae>=65536?2:1,se=oe}return z-y}t.prevCharLength=Z;function X(p,y){const C=Le.getInstance(),z=p.length,Y=y,se=ne(p,z,y),ae=C.getGraphemeBreakType(se);y+=se>=65536?2:1;let oe=ae;for(;y<z;){const _e=ne(p,z,y),be=C.getGraphemeBreakType(_e);if(Ae(oe,be))break;y+=_e>=65536?2:1,oe=be}const he=y;for(y=Y,oe=ae;y>0;){const _e=H(p,y),be=C.getGraphemeBreakType(_e);if(Ae(be,oe))break;y-=_e>=65536?2:1,oe=be}return[y,he]}function ie(p,y){return y>0&&ue(p.charCodeAt(y))?X(p,y-1):X(p,y)}t.getCharContainingOffset=ie;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function le(p){return re.test(p)}t.containsRTL=le;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function Ee(p){return fe.test(p)}t.containsEmoji=Ee;const T=/^[\t\n\r\x20-\x7E]*$/;function B(p){return T.test(p)}t.isBasicASCII=B,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(p){return t.UNUSUAL_LINE_TERMINATORS.test(p)}t.containsUnusualLineTerminators=O;function V(p){for(let y=0,C=p.length;y<C;y++)if(j(p.charCodeAt(y)))return!0;return!1}t.containsFullWidthCharacter=V;function j(p){return p>=11904&&p<=55215||p>=63744&&p<=64255||p>=65281&&p<=65374}t.isFullWidthCharacter=j;function ee(p){return p>=127462&&p<=127487||p===8986||p===8987||p===9200||p===9203||p>=9728&&p<=10175||p===11088||p===11093||p>=127744&&p<=128591||p>=128640&&p<=128764||p>=128992&&p<=129008||p>=129280&&p<=129535||p>=129648&&p<=129782}t.isEmojiImprecise=ee;function te(p,y){if(p.length<y)return p;const C=/\b/g;let z=0;for(;C.test(p)&&!(p.length-C.lastIndex<y);)z=C.lastIndex,C.lastIndex+=1;return p.substring(z).replace(/^\s/,"")}t.lcut=te;const de=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ve(p){return p&&(p=p.replace(de,""),p=p.replace(ge,""),p=p.replace(me,"")),p}t.removeAnsiEscapeCodes=ve,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(p){return!!(p&&p.length>0&&p.charCodeAt(0)===65279)}t.startsWithUTF8BOM=pe;function Se(p){return pe(p)?p.substr(1):p}t.stripUTF8BOM=Se;function ye(p,y){if(!p||!y||p.length<y.length)return!1;const C=y.length,z=p.toLowerCase();let Y=0,se=-1;for(;Y<C;){const ae=z.indexOf(y[Y],se+1);if(ae<0)return!1;se=ae,Y++}return!0}t.fuzzyContains=ye;function Te(p,y=!1){return p?(y&&(p=p.replace(/\\./g,"")),p.toLowerCase()!==p):!1}t.containsUppercaseCharacter=Te;function Ue(p){return p.charAt(0).toUpperCase()+p.slice(1)}t.uppercaseFirstLetter=Ue;function ke(p,y=1){if(y===0)return"";let C=-1;do C=p.indexOf(`
`,C+1),y--;while(y>0&&C>=0);return C===-1?p:(p[C-1]==="\r"&&C--,p.substr(0,C))}t.getNLines=ke;function Oe(p){const y=90-65+1;return p=p%(2*y),p<y?String.fromCharCode(97+p):String.fromCharCode(65+p-y)}t.singleLetterHash=Oe;function Be(p){return Le.getInstance().getGraphemeBreakType(p)}t.getGraphemeBreakType=Be;function Ae(p,y){return p===0?y!==5&&y!==7:p===2&&y===3?!1:p===4||p===2||p===3||y===4||y===2||y===3?!0:!(p===8&&(y===8||y===9||y===11||y===12)||(p===11||p===9)&&(y===9||y===10)||(p===12||p===10)&&y===10||y===5||y===13||y===7||p===1||p===13&&y===14||p===6&&y===6)}t.breakBetweenGraphemeBreakType=Ae;var Ce;(function(p){p[p.Other=0]="Other",p[p.Prepend=1]="Prepend",p[p.CR=2]="CR",p[p.LF=3]="LF",p[p.Control=4]="Control",p[p.Extend=5]="Extend",p[p.Regional_Indicator=6]="Regional_Indicator",p[p.SpacingMark=7]="SpacingMark",p[p.L=8]="L",p[p.V=9]="V",p[p.T=10]="T",p[p.LV=11]="LV",p[p.LVT=12]="LVT",p[p.ZWJ=13]="ZWJ",p[p.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Le{constructor(){this._data=Ve()}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}getGraphemeBreakType(y){if(y<32)return y===10?3:y===13?2:4;if(y<127)return 0;const C=this._data,z=C.length/3;let Y=1;for(;Y<=z;)if(y<C[3*Y])Y=2*Y;else if(y>C[3*Y+1])Y=2*Y+1;else return C[3*Y+2];return 0}}Le._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(p,y){if(p===0)return 0;const C=qe(p,y);if(C!==void 0)return C;const z=H(y,p);return p-=Me(z),p}t.getLeftDeleteOffset=We;function qe(p,y){let C=H(y,p);for(p-=Me(C);He(C)||C===65039||C===8419;){if(p===0)return;C=H(y,p),p-=Me(C)}if(!!ee(C)){if(p>=0){const z=H(y,p);z===8205&&(p-=Me(z))}return p}}function Me(p){return p>=65536?2:1}function He(p){return 127995<=p&&p<=127999}var Fe;(function(p){p[p.zwj=8205]="zwj",p[p.emojiVariantSelector=65039]="emojiVariantSelector",p[p.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),t.noBreakWhitespace="\xA0";class Ne{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ne.map){let z=function(ae){const oe=new Map;for(let he=0;he<ae.length;he+=2)oe.set(ae[he],ae[he+1]);return oe};const y=Ne.getData();let C=R.locale;(!C||!(C in y))&&(C=R.language),(!C||!(C in y))&&(C="_default");const Y=z(y._common),se=z(y[C]);for(const[ae,oe]of se)Y.set(ae,oe);Ne.map=Y}return Ne.map}static isAmbiguous(y){return Ne.getConfusablesForCurrentLocale().has(y)}static getPrimaryConfusable(y){return Ne.getConfusablesForCurrentLocale().get(y)}static getPrimaryConfusableCodePoints(){return new Set(Ne.getConfusablesForCurrentLocale().keys())}}t.AmbiguousCharacters=Ne;class we{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(we.getRawData())),this._data}static isInvisibleCharacter(y){return we.getData().has(y)}static get codePoints(){return we.getData()}}t.InvisibleCharacters=we,we._data=void 0}),J(K[24],x([0,1,3]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function S(L){return D(L,0)}t.hash=S;function D(L,w){switch(typeof L){case"object":return L===null?l(349,w):Array.isArray(L)?u(L,w):f(L,w);case"string":return _(L,w);case"boolean":return M(L,w);case"number":return l(L,w);case"undefined":return l(937,w);default:return l(617,w)}}t.doHash=D;function l(L,w){return(w<<5)-w+L|0}t.numberHash=l;function M(L,w){return l(L?433:863,w)}function _(L,w){w=l(149417,w);for(let s=0,i=L.length;s<i;s++)w=l(L.charCodeAt(s),w);return w}t.stringHash=_;function u(L,w){return w=l(104579,w),L.reduce((s,i)=>D(i,s),w)}function f(L,w){return w=l(181387,w),Object.keys(L).sort().reduce((s,i)=>(s=_(i,s),D(L[i],s)),w)}class b{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=D(w,this._value),this._value}}t.Hasher=b;var A;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function v(L,w,s=32){const i=s-w,r=~((1<<i)-1);return(L<<w|(r&L)>>>i)>>>0}function m(L,w=0,s=L.byteLength,i=0){for(let r=0;r<s;r++)L[w+r]=i}function e(L,w,s="0"){for(;L.length<w;)L=s+L;return L}function g(L,w=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(s=>s.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),w/4)}t.toHexString=g;class N{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const s=w.length;if(s===0)return;const i=this._buff;let r=this._buffLen,a=this._leftoverHighSurrogate,d,h;for(a!==0?(d=a,h=-1,a=0):(d=w.charCodeAt(0),h=0);;){let o=d;if(R.isHighSurrogate(d))if(h+1<s){const c=w.charCodeAt(h+1);R.isLowSurrogate(c)?(h++,o=R.computeCodePoint(d,c)):o=65533}else{a=d;break}else R.isLowSurrogate(d)&&(o=65533);if(r=this._push(i,r,o),h++,h<s)d=w.charCodeAt(h);else break}this._buffLen=r,this._leftoverHighSurrogate=a}_push(w,s,i){return i<128?w[s++]=i:i<2048?(w[s++]=192|(i&1984)>>>6,w[s++]=128|(i&63)>>>0):i<65536?(w[s++]=224|(i&61440)>>>12,w[s++]=128|(i&4032)>>>6,w[s++]=128|(i&63)>>>0):(w[s++]=240|(i&1835008)>>>18,w[s++]=128|(i&258048)>>>12,w[s++]=128|(i&4032)>>>6,w[s++]=128|(i&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=N._bigBlock32,s=this._buffDV;for(let P=0;P<64;P+=4)w.setUint32(P,s.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)w.setUint32(P,v(w.getUint32(P-12,!1)^w.getUint32(P-32,!1)^w.getUint32(P-56,!1)^w.getUint32(P-64,!1),1),!1);let i=this._h0,r=this._h1,a=this._h2,d=this._h3,h=this._h4,o,c,E;for(let P=0;P<80;P++)P<20?(o=r&a|~r&d,c=1518500249):P<40?(o=r^a^d,c=1859775393):P<60?(o=r&a|r&d|a&d,c=2400959708):(o=r^a^d,c=3395469782),E=v(i,5)+o+h+c+w.getUint32(P*4,!1)&4294967295,h=d,d=a,a=v(r,30),r=i,i=E;this._h0=this._h0+i&4294967295,this._h1=this._h1+r&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+h&4294967295}}t.StringSHA1=N,N._bigBlock32=new DataView(new ArrayBuffer(320))}),J(K[12],x([0,1,16,24]),function(U,t,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class D{constructor(v){this.source=v}getElements(){const v=this.source,m=new Int32Array(v.length);for(let e=0,g=v.length;e<g;e++)m[e]=v.charCodeAt(e);return m}}t.StringDiffSequence=D;function l(A,v,m){return new b(new D(A),new D(v)).ComputeDiff(m).changes}t.stringDiff=l;class M{static Assert(v,m){if(!v)throw new Error(m)}}t.Debug=M;class _{static Copy(v,m,e,g,N){for(let L=0;L<N;L++)e[g+L]=v[m+L]}static Copy2(v,m,e,g,N){for(let L=0;L<N;L++)e[g+L]=v[m+L]}}t.MyArray=_;var u;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new R.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(v,m){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(v,m){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class b{constructor(v,m,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=v,this._modifiedSequence=m;const[g,N,L]=b._getElements(v),[w,s,i]=b._getElements(m);this._hasStrings=L&&i,this._originalStringElements=g,this._originalElementsOrHash=N,this._modifiedStringElements=w,this._modifiedElementsOrHash=s,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(v){return v.length>0&&typeof v[0]=="string"}static _getElements(v){const m=v.getElements();if(b._isStringArray(m)){const e=new Int32Array(m.length);for(let g=0,N=m.length;g<N;g++)e[g]=(0,S.stringHash)(m[g],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(v,m){return this._originalElementsOrHash[v]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[v]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(v,m){if(!this.ElementsAreEqual(v,m))return!1;const e=b._getStrictElement(this._originalSequence,v),g=b._getStrictElement(this._modifiedSequence,m);return e===g}static _getStrictElement(v,m){return typeof v.getStrictElement=="function"?v.getStrictElement(m):null}OriginalElementsAreEqual(v,m){return this._originalElementsOrHash[v]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[v]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(v,m){return this._modifiedElementsOrHash[v]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[v]===this._modifiedStringElements[m]:!0}ComputeDiff(v){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,v)}_ComputeDiff(v,m,e,g,N){const L=[!1];let w=this.ComputeDiffRecursive(v,m,e,g,L);return N&&(w=this.PrettifyChanges(w)),{quitEarly:L[0],changes:w}}ComputeDiffRecursive(v,m,e,g,N){for(N[0]=!1;v<=m&&e<=g&&this.ElementsAreEqual(v,e);)v++,e++;for(;m>=v&&g>=e&&this.ElementsAreEqual(m,g);)m--,g--;if(v>m||e>g){let a;return e<=g?(M.Assert(v===m+1,"originalStart should only be one more than originalEnd"),a=[new R.DiffChange(v,0,e,g-e+1)]):v<=m?(M.Assert(e===g+1,"modifiedStart should only be one more than modifiedEnd"),a=[new R.DiffChange(v,m-v+1,e,0)]):(M.Assert(v===m+1,"originalStart should only be one more than originalEnd"),M.Assert(e===g+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const L=[0],w=[0],s=this.ComputeRecursionPoint(v,m,e,g,L,w,N),i=L[0],r=w[0];if(s!==null)return s;if(!N[0]){const a=this.ComputeDiffRecursive(v,i,e,r,N);let d=[];return N[0]?d=[new R.DiffChange(i+1,m-(i+1)+1,r+1,g-(r+1)+1)]:d=this.ComputeDiffRecursive(i+1,m,r+1,g,N),this.ConcatenateChanges(a,d)}return[new R.DiffChange(v,m-v+1,e,g-e+1)]}WALKTRACE(v,m,e,g,N,L,w,s,i,r,a,d,h,o,c,E,P,F){let I=null,k=null,W=new f,q=m,Q=e,G=h[0]-E[0]-g,ue=-1073741824,n=this.m_forwardHistory.length-1;do{const ne=G+v;ne===q||ne<Q&&i[ne-1]<i[ne+1]?(a=i[ne+1],o=a-G-g,a<ue&&W.MarkNextChange(),ue=a,W.AddModifiedElement(a+1,o),G=ne+1-v):(a=i[ne-1]+1,o=a-G-g,a<ue&&W.MarkNextChange(),ue=a-1,W.AddOriginalElement(a,o+1),G=ne-1-v),n>=0&&(i=this.m_forwardHistory[n],v=i[0],q=1,Q=i.length-1)}while(--n>=-1);if(I=W.getReverseChanges(),F[0]){let ne=h[0]+1,H=E[0]+1;if(I!==null&&I.length>0){const $=I[I.length-1];ne=Math.max(ne,$.getOriginalEnd()),H=Math.max(H,$.getModifiedEnd())}k=[new R.DiffChange(ne,d-ne+1,H,c-H+1)]}else{W=new f,q=L,Q=w,G=h[0]-E[0]-s,ue=1073741824,n=P?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ne=G+N;ne===q||ne<Q&&r[ne-1]>=r[ne+1]?(a=r[ne+1]-1,o=a-G-s,a>ue&&W.MarkNextChange(),ue=a+1,W.AddOriginalElement(a+1,o+1),G=ne+1-N):(a=r[ne-1],o=a-G-s,a>ue&&W.MarkNextChange(),ue=a,W.AddModifiedElement(a+1,o+1),G=ne-1-N),n>=0&&(r=this.m_reverseHistory[n],N=r[0],q=1,Q=r.length-1)}while(--n>=-1);k=W.getChanges()}return this.ConcatenateChanges(I,k)}ComputeRecursionPoint(v,m,e,g,N,L,w){let s=0,i=0,r=0,a=0,d=0,h=0;v--,e--,N[0]=0,L[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const o=m-v+(g-e),c=o+1,E=new Int32Array(c),P=new Int32Array(c),F=g-e,I=m-v,k=v-e,W=m-g,Q=(I-F)%2==0;E[F]=v,P[I]=m,w[0]=!1;for(let G=1;G<=o/2+1;G++){let ue=0,n=0;r=this.ClipDiagonalBound(F-G,G,F,c),a=this.ClipDiagonalBound(F+G,G,F,c);for(let H=r;H<=a;H+=2){H===r||H<a&&E[H-1]<E[H+1]?s=E[H+1]:s=E[H-1]+1,i=s-(H-F)-k;const $=s;for(;s<m&&i<g&&this.ElementsAreEqual(s+1,i+1);)s++,i++;if(E[H]=s,s+i>ue+n&&(ue=s,n=i),!Q&&Math.abs(H-I)<=G-1&&s>=P[H])return N[0]=s,L[0]=i,$<=P[H]&&1447>0&&G<=1447+1?this.WALKTRACE(F,r,a,k,I,d,h,W,E,P,s,m,N,i,g,L,Q,w):null}const ne=(ue-v+(n-e)-G)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ue,ne))return w[0]=!0,N[0]=ue,L[0]=n,ne>0&&1447>0&&G<=1447+1?this.WALKTRACE(F,r,a,k,I,d,h,W,E,P,s,m,N,i,g,L,Q,w):(v++,e++,[new R.DiffChange(v,m-v+1,e,g-e+1)]);d=this.ClipDiagonalBound(I-G,G,I,c),h=this.ClipDiagonalBound(I+G,G,I,c);for(let H=d;H<=h;H+=2){H===d||H<h&&P[H-1]>=P[H+1]?s=P[H+1]-1:s=P[H-1],i=s-(H-I)-W;const $=s;for(;s>v&&i>e&&this.ElementsAreEqual(s,i);)s--,i--;if(P[H]=s,Q&&Math.abs(H-F)<=G&&s<=E[H])return N[0]=s,L[0]=i,$>=E[H]&&1447>0&&G<=1447+1?this.WALKTRACE(F,r,a,k,I,d,h,W,E,P,s,m,N,i,g,L,Q,w):null}if(G<=1447){let H=new Int32Array(a-r+2);H[0]=F-r+1,_.Copy2(E,r,H,1,a-r+1),this.m_forwardHistory.push(H),H=new Int32Array(h-d+2),H[0]=I-d+1,_.Copy2(P,d,H,1,h-d+1),this.m_reverseHistory.push(H)}}return this.WALKTRACE(F,r,a,k,I,d,h,W,E,P,s,m,N,i,g,L,Q,w)}PrettifyChanges(v){for(let m=0;m<v.length;m++){const e=v[m],g=m<v.length-1?v[m+1].originalStart:this._originalElementsOrHash.length,N=m<v.length-1?v[m+1].modifiedStart:this._modifiedElementsOrHash.length,L=e.originalLength>0,w=e.modifiedLength>0;for(;e.originalStart+e.originalLength<g&&e.modifiedStart+e.modifiedLength<N&&(!L||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!w||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const i=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!i)break;e.originalStart++,e.modifiedStart++}let s=[null];if(m<v.length-1&&this.ChangesOverlap(v[m],v[m+1],s)){v[m]=s[0],v.splice(m+1,1),m--;continue}}for(let m=v.length-1;m>=0;m--){const e=v[m];let g=0,N=0;if(m>0){const a=v[m-1];g=a.originalStart+a.originalLength,N=a.modifiedStart+a.modifiedLength}const L=e.originalLength>0,w=e.modifiedLength>0;let s=0,i=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let a=1;;a++){const d=e.originalStart-a,h=e.modifiedStart-a;if(d<g||h<N||L&&!this.OriginalElementsAreEqual(d,d+e.originalLength)||w&&!this.ModifiedElementsAreEqual(h,h+e.modifiedLength))break;const c=(d===g&&h===N?5:0)+this._boundaryScore(d,e.originalLength,h,e.modifiedLength);c>i&&(i=c,s=a)}e.originalStart-=s,e.modifiedStart-=s;const r=[null];if(m>0&&this.ChangesOverlap(v[m-1],v[m],r)){v[m-1]=r[0],v.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,e=v.length;m<e;m++){const g=v[m-1],N=v[m],L=N.originalStart-g.originalStart-g.originalLength,w=g.originalStart,s=N.originalStart+N.originalLength,i=s-w,r=g.modifiedStart,a=N.modifiedStart+N.modifiedLength,d=a-r;if(L<5&&i<20&&d<20){const h=this._findBetterContiguousSequence(w,i,r,d,L);if(h){const[o,c]=h;(o!==g.originalStart+g.originalLength||c!==g.modifiedStart+g.modifiedLength)&&(g.originalLength=o-g.originalStart,g.modifiedLength=c-g.modifiedStart,N.originalStart=o+L,N.modifiedStart=c+L,N.originalLength=s-N.originalStart,N.modifiedLength=a-N.modifiedStart)}}}return v}_findBetterContiguousSequence(v,m,e,g,N){if(m<N||g<N)return null;const L=v+m-N+1,w=e+g-N+1;let s=0,i=0,r=0;for(let a=v;a<L;a++)for(let d=e;d<w;d++){const h=this._contiguousSequenceScore(a,d,N);h>0&&h>s&&(s=h,i=a,r=d)}return s>0?[i,r]:null}_contiguousSequenceScore(v,m,e){let g=0;for(let N=0;N<e;N++){if(!this.ElementsAreEqual(v+N,m+N))return 0;g+=this._originalStringElements[v+N].length}return g}_OriginalIsBoundary(v){return v<=0||v>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[v])}_OriginalRegionIsBoundary(v,m){if(this._OriginalIsBoundary(v)||this._OriginalIsBoundary(v-1))return!0;if(m>0){const e=v+m;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(v){return v<=0||v>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[v])}_ModifiedRegionIsBoundary(v,m){if(this._ModifiedIsBoundary(v)||this._ModifiedIsBoundary(v-1))return!0;if(m>0){const e=v+m;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(v,m,e,g){const N=this._OriginalRegionIsBoundary(v,m)?1:0,L=this._ModifiedRegionIsBoundary(e,g)?1:0;return N+L}ConcatenateChanges(v,m){let e=[];if(v.length===0||m.length===0)return m.length>0?m:v;if(this.ChangesOverlap(v[v.length-1],m[0],e)){const g=new Array(v.length+m.length-1);return _.Copy(v,0,g,0,v.length-1),g[v.length-1]=e[0],_.Copy(m,1,g,v.length,m.length-1),g}else{const g=new Array(v.length+m.length);return _.Copy(v,0,g,0,v.length),_.Copy(m,0,g,v.length,m.length),g}}ChangesOverlap(v,m,e){if(M.Assert(v.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),M.Assert(v.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),v.originalStart+v.originalLength>=m.originalStart||v.modifiedStart+v.modifiedLength>=m.modifiedStart){const g=v.originalStart;let N=v.originalLength;const L=v.modifiedStart;let w=v.modifiedLength;return v.originalStart+v.originalLength>=m.originalStart&&(N=m.originalStart+m.originalLength-v.originalStart),v.modifiedStart+v.modifiedLength>=m.modifiedStart&&(w=m.modifiedStart+m.modifiedLength-v.modifiedStart),e[0]=new R.DiffChange(g,N,L,w),!0}else return e[0]=null,!1}ClipDiagonalBound(v,m,e,g){if(v>=0&&v<g)return v;const N=e,L=g-e-1,w=m%2==0;if(v<0){const s=N%2==0;return w===s?0:1}else{const s=L%2==0;return w===s?g-1:g-2}}}t.LcsDiff=b}),J(K[6],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPromise=t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function R(F){return Array.isArray(F)}t.isArray=R;function S(F){return typeof F=="string"}t.isString=S;function D(F){return Array.isArray(F)&&F.every(I=>S(I))}t.isStringArray=D;function l(F){return typeof F=="object"&&F!==null&&!Array.isArray(F)&&!(F instanceof RegExp)&&!(F instanceof Date)}t.isObject=l;function M(F){return typeof F=="number"&&!isNaN(F)}t.isNumber=M;function _(F){return!!F&&typeof F[Symbol.iterator]=="function"}t.isIterable=_;function u(F){return F===!0||F===!1}t.isBoolean=u;function f(F){return typeof F=="undefined"}t.isUndefined=f;function b(F){return!A(F)}t.isDefined=b;function A(F){return f(F)||F===null}t.isUndefinedOrNull=A;function v(F,I){if(!F)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}t.assertType=v;function m(F){if(A(F))throw new Error("Assertion Failed: argument is undefined or null");return F}t.assertIsDefined=m;function e(...F){const I=[];for(let k=0;k<F.length;k++){const W=F[k];if(A(W))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);I.push(W)}return I}t.assertAllDefined=e;const g=Object.prototype.hasOwnProperty;function N(F){if(!l(F))return!1;for(let I in F)if(g.call(F,I))return!1;return!0}t.isEmptyObject=N;function L(F){return typeof F=="function"}t.isFunction=L;function w(...F){return F.length>0&&F.every(L)}t.areFunctions=w;function s(F,I){const k=Math.min(F.length,I.length);for(let W=0;W<k;W++)i(F[W],I[W])}t.validateConstraints=s;function i(F,I){if(S(I)){if(typeof F!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(L(I)){try{if(F instanceof I)return}catch{}if(!A(F)&&F.constructor===I||I.length===1&&I.call(void 0,F)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=i;function r(F){let I=[],k=Object.getPrototypeOf(F);for(;Object.prototype!==k;)I=I.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return I}t.getAllPropertyNames=r;function a(F){const I=[];for(const k of r(F))typeof F[k]=="function"&&I.push(k);return I}t.getAllMethodNames=a;function d(F,I){const k=q=>function(){const Q=Array.prototype.slice.call(arguments,0);return I(q,Q)};let W={};for(const q of F)W[q]=k(q);return W}t.createProxyObject=d;function h(F){return F===null?void 0:F}t.withNullAsUndefined=h;function o(F){return typeof F=="undefined"?null:F}t.withUndefinedAsNull=o;function c(F){return class{constructor(){return new Proxy({},{get(I,k){if(I[k])return I[k];throw new Error(`Not Implemented: ${F}->${String(k)}`)}})}}}t.NotImplementedProxy=c;function E(F,I="Unreachable"){throw new Error(I)}t.assertNever=E;function P(F){return!!F&&typeof F.then=="function"&&typeof F.catch=="function"}t.isPromise=P}),J(K[25],x([0,1,6]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const N=Array.isArray(g)?[]:{};return Object.keys(g).forEach(L=>{g[L]&&typeof g[L]=="object"?N[L]=S(g[L]):N[L]=g[L]}),N}t.deepClone=S;function D(g){if(!g||typeof g!="object")return g;const N=[g];for(;N.length>0;){const L=N.shift();Object.freeze(L);for(const w in L)if(l.call(L,w)){const s=L[w];typeof s=="object"&&!Object.isFrozen(s)&&N.push(s)}}return g}t.deepFreeze=D;const l=Object.prototype.hasOwnProperty;function M(g,N){return _(g,N,new Set)}t.cloneAndChange=M;function _(g,N,L){if((0,R.isUndefinedOrNull)(g))return g;const w=N(g);if(typeof w!="undefined")return w;if((0,R.isArray)(g)){const s=[];for(const i of g)s.push(_(i,N,L));return s}if((0,R.isObject)(g)){if(L.has(g))throw new Error("Cannot clone recursive data-structure");L.add(g);const s={};for(let i in g)l.call(g,i)&&(s[i]=_(g[i],N,L));return L.delete(g),s}return g}function u(g,N,L=!0){return(0,R.isObject)(g)?((0,R.isObject)(N)&&Object.keys(N).forEach(w=>{w in g?L&&((0,R.isObject)(g[w])&&(0,R.isObject)(N[w])?u(g[w],N[w],L):g[w]=N[w]):g[w]=N[w]}),g):N}t.mixin=u;function f(g,N){if(g===N)return!0;if(g==null||N===null||N===void 0||typeof g!=typeof N||typeof g!="object"||Array.isArray(g)!==Array.isArray(N))return!1;let L,w;if(Array.isArray(g)){if(g.length!==N.length)return!1;for(L=0;L<g.length;L++)if(!f(g[L],N[L]))return!1}else{const s=[];for(w in g)s.push(w);s.sort();const i=[];for(w in N)i.push(w);if(i.sort(),!f(s,i))return!1;for(L=0;L<s.length;L++)if(!f(g[s[L]],N[s[L]]))return!1}return!0}t.equals=f;function b(g){const N=new Set;return JSON.stringify(g,(L,w)=>{if((0,R.isObject)(w)||Array.isArray(w)){if(N.has(w))return"[Circular]";N.add(w)}return w})}t.safeStringify=b;function A(g,N,L){const w=N(g);return typeof w=="undefined"?L:w}t.getOrDefault=A;function v(g,N){const L=Object.create(null);return!g||!N||Object.keys(N).forEach(s=>{const i=g[s],r=N[s];f(i,r)||(L[s]=r)}),L}t.distinct=v;function m(g,N){const L=N.toLowerCase(),w=Object.keys(g).find(s=>s.toLowerCase()===L);return w?g[w]:g[N]}t.getCaseInsensitive=m;function e(g,N){const L=Object.create(null);for(const[w,s]of Object.entries(g))N(w,s)&&(L[w]=s);return L}t.filter=e}),J(K[13],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var R;(function(l){l[l.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",l[l.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",l[l.MAX_UINT_8=255]="MAX_UINT_8",l[l.MAX_UINT_16=65535]="MAX_UINT_16",l[l.MAX_UINT_32=4294967295]="MAX_UINT_32",l[l.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R=t.Constants||(t.Constants={}));function S(l){return l<0?0:l>255?255:l|0}t.toUint8=S;function D(l){return l<0?0:l>4294967295?4294967295:l|0}t.toUint32=D}),J(K[14],x([0,1,22,2]),function(U,t,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const D=/^\w[\w\d+.-]*$/,l=/^\//,M=/^\/\//;function _(h,o){if(!h.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!D.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!l.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(h,o){return!h&&!o?"file":h}function f(h,o){switch(h){case"https":case"http":case"file":o?o[0]!==A&&(o=A+o):o=A;break}return o}const b="",A="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(o,c,E,P,F,I=!1){typeof o=="object"?(this.scheme=o.scheme||b,this.authority=o.authority||b,this.path=o.path||b,this.query=o.query||b,this.fragment=o.fragment||b):(this.scheme=u(o,I),this.authority=c||b,this.path=f(this.scheme,E||b),this.query=P||b,this.fragment=F||b,_(this,I))}static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return s(this,!1)}with(o){if(!o)return this;let{scheme:c,authority:E,path:P,query:F,fragment:I}=o;return c===void 0?c=this.scheme:c===null&&(c=b),E===void 0?E=this.authority:E===null&&(E=b),P===void 0?P=this.path:P===null&&(P=b),F===void 0?F=this.query:F===null&&(F=b),I===void 0?I=this.fragment:I===null&&(I=b),c===this.scheme&&E===this.authority&&P===this.path&&F===this.query&&I===this.fragment?this:new g(c,E,P,F,I)}static parse(o,c=!1){const E=v.exec(o);return E?new g(E[2]||b,d(E[4]||b),d(E[5]||b),d(E[7]||b),d(E[9]||b),c):new g(b,b,b,b,b)}static file(o){let c=b;if(S.isWindows&&(o=o.replace(/\\/g,A)),o[0]===A&&o[1]===A){const E=o.indexOf(A,2);E===-1?(c=o.substring(2),o=A):(c=o.substring(2,E),o=o.substring(E)||A)}return new g("file",c,o,b,b)}static from(o){const c=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return _(c,!0),c}static joinPath(o,...c){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return S.isWindows&&o.scheme==="file"?E=m.file(R.win32.join(s(o,!0),...c)).path:E=R.posix.join(o.path,...c),o.with({path:E})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const c=new g(o);return c._formatted=o.external,c._fsPath=o._sep===e?o.fsPath:null,c}}else return o}}t.URI=m;const e=S.isWindows?1:void 0;class g extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=e),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const N={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function L(h,o){let c,E=-1;for(let P=0;P<h.length;P++){const F=h.charCodeAt(P);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||o&&F===47)E!==-1&&(c+=encodeURIComponent(h.substring(E,P)),E=-1),c!==void 0&&(c+=h.charAt(P));else{c===void 0&&(c=h.substr(0,P));const I=N[F];I!==void 0?(E!==-1&&(c+=encodeURIComponent(h.substring(E,P)),E=-1),c+=I):E===-1&&(E=P)}}return E!==-1&&(c+=encodeURIComponent(h.substring(E))),c!==void 0?c:h}function w(h){let o;for(let c=0;c<h.length;c++){const E=h.charCodeAt(c);E===35||E===63?(o===void 0&&(o=h.substr(0,c)),o+=N[E]):o!==void 0&&(o+=h[c])}return o!==void 0?o:h}function s(h,o){let c;return h.authority&&h.path.length>1&&h.scheme==="file"?c=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?o?c=h.path.substr(1):c=h.path[1].toLowerCase()+h.path.substr(2):c=h.path,S.isWindows&&(c=c.replace(/\//g,"\\")),c}t.uriToFsPath=s;function i(h,o){const c=o?w:L;let E="",{scheme:P,authority:F,path:I,query:k,fragment:W}=h;if(P&&(E+=P,E+=":"),(F||P==="file")&&(E+=A,E+=A),F){let q=F.indexOf("@");if(q!==-1){const Q=F.substr(0,q);F=F.substr(q+1),q=Q.indexOf(":"),q===-1?E+=c(Q,!1):(E+=c(Q.substr(0,q),!1),E+=":",E+=c(Q.substr(q+1),!1)),E+="@"}F=F.toLowerCase(),q=F.indexOf(":"),q===-1?E+=c(F,!1):(E+=c(F.substr(0,q),!1),E+=F.substr(q))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const q=I.charCodeAt(1);q>=65&&q<=90&&(I=`/${String.fromCharCode(q+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const q=I.charCodeAt(0);q>=65&&q<=90&&(I=`${String.fromCharCode(q+32)}:${I.substr(2)}`)}E+=c(I,!0)}return k&&(E+="?",E+=c(k,!1)),W&&(E+="#",E+=o?W:L(W,!1)),E}function r(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+r(h.substr(3)):h}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(h){return h.match(a)?h.replace(a,o=>r(o)):h}}),J(K[40],x([0,1,7,8,10,2,6,3]),function(U,t,R,S,D,l,M,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const u="$initialize";let f=!1;function b(h){!l.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(h.message))}t.logOnceWebWorkerWarning=b;var A;(function(h){h[h.Request=0]="Request",h[h.Reply=1]="Reply",h[h.SubscribeEvent=2]="SubscribeEvent",h[h.Event=3]="Event",h[h.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class v{constructor(o,c,E,P){this.vsWorker=o,this.req=c,this.method=E,this.args=P,this.type=0}}class m{constructor(o,c,E,P){this.vsWorker=o,this.seq=c,this.res=E,this.err=P,this.type=1}}class e{constructor(o,c,E,P){this.vsWorker=o,this.req=c,this.eventName=E,this.arg=P,this.type=2}}class g{constructor(o,c,E){this.vsWorker=o,this.req=c,this.event=E,this.type=3}}class N{constructor(o,c){this.vsWorker=o,this.req=c,this.type=4}}class L{constructor(o){this._workerId=-1,this._handler=o,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(o){this._workerId=o}sendMessage(o,c){const E=String(++this._lastSentReq);return new Promise((P,F)=>{this._pendingReplies[E]={resolve:P,reject:F},this._send(new v(this._workerId,E,o,c))})}listen(o,c){let E=null;const P=new S.Emitter({onFirstListenerAdd:()=>{E=String(++this._lastSentReq),this._pendingEmitters.set(E,P),this._send(new e(this._workerId,E,o,c))},onLastListenerRemove:()=>{this._pendingEmitters.delete(E),this._send(new N(this._workerId,E)),E=null}});return P.event}handleMessage(o){!o||!o.vsWorker||this._workerId!==-1&&o.vsWorker!==this._workerId||this._handleMessage(o)}_handleMessage(o){switch(o.type){case 1:return this._handleReplyMessage(o);case 0:return this._handleRequestMessage(o);case 2:return this._handleSubscribeEventMessage(o);case 3:return this._handleEventMessage(o);case 4:return this._handleUnsubscribeEventMessage(o)}}_handleReplyMessage(o){if(!this._pendingReplies[o.seq]){console.warn("Got reply to unknown seq");return}let c=this._pendingReplies[o.seq];if(delete this._pendingReplies[o.seq],o.err){let E=o.err;o.err.$isError&&(E=new Error,E.name=o.err.name,E.message=o.err.message,E.stack=o.err.stack),c.reject(E);return}c.resolve(o.res)}_handleRequestMessage(o){let c=o.req;this._handler.handleMessage(o.method,o.args).then(P=>{this._send(new m(this._workerId,c,P,void 0))},P=>{P.detail instanceof Error&&(P.detail=(0,R.transformErrorForSerialization)(P.detail)),this._send(new m(this._workerId,c,void 0,(0,R.transformErrorForSerialization)(P)))})}_handleSubscribeEventMessage(o){const c=o.req,E=this._handler.handleEvent(o.eventName,o.arg)(P=>{this._send(new g(this._workerId,c,P))});this._pendingEvents.set(c,E)}_handleEventMessage(o){if(!this._pendingEmitters.has(o.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(o.req).fire(o.event)}_handleUnsubscribeEventMessage(o){if(!this._pendingEvents.has(o.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(o.req).dispose(),this._pendingEvents.delete(o.req)}_send(o){let c=[];if(o.type===0)for(let E=0;E<o.args.length;E++)o.args[E]instanceof ArrayBuffer&&c.push(o.args[E]);else o.type===1&&o.res instanceof ArrayBuffer&&c.push(o.res);this._handler.sendMessage(o,c)}}class w extends D.Disposable{constructor(o,c,E){super();let P=null;this._worker=this._register(o.create("vs/base/common/worker/simpleWorker",q=>{this._protocol.handleMessage(q)},q=>{P&&P(q)})),this._protocol=new L({sendMessage:(q,Q)=>{this._worker.postMessage(q,Q)},handleMessage:(q,Q)=>{if(typeof E[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(E[q].apply(E,Q))}catch(G){return Promise.reject(G)}},handleEvent:(q,Q)=>{if(i(q)){const G=E[q].call(E,Q);if(typeof G!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return G}if(s(q)){const G=E[q];if(typeof G!="function")throw new Error(`Missing event ${q} on main thread host.`);return G}throw new Error(`Malformed event name ${q}`)}}),this._protocol.setWorkerId(this._worker.getId());let F=null;typeof l.globals.require!="undefined"&&typeof l.globals.require.getConfig=="function"?F=l.globals.require.getConfig():typeof l.globals.requirejs!="undefined"&&(F=l.globals.requirejs.s.contexts._.config);const I=M.getAllMethodNames(E);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(F)),c,I]);const k=(q,Q)=>this._request(q,Q),W=(q,Q)=>this._protocol.listen(q,Q);this._lazyProxy=new Promise((q,Q)=>{P=Q,this._onModuleLoaded.then(G=>{q(r(G,k,W))},G=>{Q(G),this._onError("Worker failed to load "+c,G)})})}getProxyObject(){return this._lazyProxy}_request(o,c){return new Promise((E,P)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(o,c).then(E,P)},P)})}_onError(o,c){console.error(o),console.info(c)}}t.SimpleWorkerClient=w;function s(h){return h[0]==="o"&&h[1]==="n"&&_.isUpperAsciiLetter(h.charCodeAt(2))}function i(h){return/^onDynamic/.test(h)&&_.isUpperAsciiLetter(h.charCodeAt(9))}function r(h,o,c){const E=I=>function(){const k=Array.prototype.slice.call(arguments,0);return o(I,k)},P=I=>function(k){return c(I,k)};let F={};for(const I of h){if(i(I)){F[I]=P(I);continue}if(s(I)){F[I]=c(I,void 0);continue}F[I]=E(I)}return F}class a{constructor(o,c){this._requestHandlerFactory=c,this._requestHandler=null,this._protocol=new L({sendMessage:(E,P)=>{o(E,P)},handleMessage:(E,P)=>this._handleMessage(E,P),handleEvent:(E,P)=>this._handleEvent(E,P)})}onmessage(o){this._protocol.handleMessage(o)}_handleMessage(o,c){if(o===u)return this.initialize(c[0],c[1],c[2],c[3]);if(!this._requestHandler||typeof this._requestHandler[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this._requestHandler[o].apply(this._requestHandler,c))}catch(E){return Promise.reject(E)}}_handleEvent(o,c){if(!this._requestHandler)throw new Error("Missing requestHandler");if(i(o)){const E=this._requestHandler[o].call(this._requestHandler,c);if(typeof E!="function")throw new Error(`Missing dynamic event ${o} on request handler.`);return E}if(s(o)){const E=this._requestHandler[o];if(typeof E!="function")throw new Error(`Missing event ${o} on request handler.`);return E}throw new Error(`Malformed event name ${o}`)}initialize(o,c,E,P){this._protocol.setWorkerId(o);const k=r(P,(W,q)=>this._protocol.sendMessage(W,q),(W,q)=>this._protocol.listen(W,q));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(k),Promise.resolve(M.getAllMethodNames(this._requestHandler))):(c&&(typeof c.baseUrl!="undefined"&&delete c.baseUrl,typeof c.paths!="undefined"&&typeof c.paths.vs!="undefined"&&delete c.paths.vs,typeof c.trustedTypesPolicy!==void 0&&delete c.trustedTypesPolicy,c.catchError=!0,l.globals.require.config(c)),new Promise((W,q)=>{(l.globals.require||U)([E],G=>{if(this._requestHandler=G.create(k),!this._requestHandler){q(new Error("No RequestHandler!"));return}W(M.getAllMethodNames(this._requestHandler))},q)}))}}t.SimpleWorkerServer=a;function d(h){return new a(h,null)}t.create=d}),J(K[15],x([0,1,13]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class S{constructor(_){let u=(0,R.toUint8)(_);this._defaultValue=u,this._asciiMap=S._createAsciiMap(u),this._map=new Map}static _createAsciiMap(_){let u=new Uint8Array(256);for(let f=0;f<256;f++)u[f]=_;return u}set(_,u){let f=(0,R.toUint8)(u);_>=0&&_<256?this._asciiMap[_]=f:this._map.set(_,f)}get(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue}}t.CharacterClassifier=S;var D;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(D||(D={}));class l{constructor(){this._actual=new S(0)}add(_){this._actual.set(_,1)}has(_){return this._actual.get(_)===1}}t.CharacterSet=l}),J(K[26],x([0,1,15]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var S;(function(M){M[M.Regular=0]="Regular",M[M.Whitespace=1]="Whitespace",M[M.WordSeparator=2]="WordSeparator"})(S=t.WordCharacterClass||(t.WordCharacterClass={}));class D extends R.CharacterClassifier{constructor(_){super(0);for(let u=0,f=_.length;u<f;u++)this.set(_.charCodeAt(u),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=D;function l(M){let _={};return u=>(_.hasOwnProperty(u)||(_[u]=M(u)),_[u])}t.getMapForWordSeparators=l(M=>new D(M))}),J(K[4],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class R{constructor(D,l){this.lineNumber=D,this.column=l}with(D=this.lineNumber,l=this.column){return D===this.lineNumber&&l===this.column?this:new R(D,l)}delta(D=0,l=0){return this.with(this.lineNumber+D,this.column+l)}equals(D){return R.equals(this,D)}static equals(D,l){return!D&&!l?!0:!!D&&!!l&&D.lineNumber===l.lineNumber&&D.column===l.column}isBefore(D){return R.isBefore(this,D)}static isBefore(D,l){return D.lineNumber<l.lineNumber?!0:l.lineNumber<D.lineNumber?!1:D.column<l.column}isBeforeOrEqual(D){return R.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,l){return D.lineNumber<l.lineNumber?!0:l.lineNumber<D.lineNumber?!1:D.column<=l.column}static compare(D,l){let M=D.lineNumber|0,_=l.lineNumber|0;if(M===_){let u=D.column|0,f=l.column|0;return u-f}return M-_}clone(){return new R(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new R(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}t.Position=R}),J(K[5],x([0,1,4]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class S{constructor(l,M,_,u){l>_||l===_&&M>u?(this.startLineNumber=_,this.startColumn=u,this.endLineNumber=l,this.endColumn=M):(this.startLineNumber=l,this.startColumn=M,this.endLineNumber=_,this.endColumn=u)}isEmpty(){return S.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return S.containsPosition(this,l)}static containsPosition(l,M){return!(M.lineNumber<l.startLineNumber||M.lineNumber>l.endLineNumber||M.lineNumber===l.startLineNumber&&M.column<l.startColumn||M.lineNumber===l.endLineNumber&&M.column>l.endColumn)}static strictContainsPosition(l,M){return!(M.lineNumber<l.startLineNumber||M.lineNumber>l.endLineNumber||M.lineNumber===l.startLineNumber&&M.column<=l.startColumn||M.lineNumber===l.endLineNumber&&M.column>=l.endColumn)}containsRange(l){return S.containsRange(this,l)}static containsRange(l,M){return!(M.startLineNumber<l.startLineNumber||M.endLineNumber<l.startLineNumber||M.startLineNumber>l.endLineNumber||M.endLineNumber>l.endLineNumber||M.startLineNumber===l.startLineNumber&&M.startColumn<l.startColumn||M.endLineNumber===l.endLineNumber&&M.endColumn>l.endColumn)}strictContainsRange(l){return S.strictContainsRange(this,l)}static strictContainsRange(l,M){return!(M.startLineNumber<l.startLineNumber||M.endLineNumber<l.startLineNumber||M.startLineNumber>l.endLineNumber||M.endLineNumber>l.endLineNumber||M.startLineNumber===l.startLineNumber&&M.startColumn<=l.startColumn||M.endLineNumber===l.endLineNumber&&M.endColumn>=l.endColumn)}plusRange(l){return S.plusRange(this,l)}static plusRange(l,M){let _,u,f,b;return M.startLineNumber<l.startLineNumber?(_=M.startLineNumber,u=M.startColumn):M.startLineNumber===l.startLineNumber?(_=M.startLineNumber,u=Math.min(M.startColumn,l.startColumn)):(_=l.startLineNumber,u=l.startColumn),M.endLineNumber>l.endLineNumber?(f=M.endLineNumber,b=M.endColumn):M.endLineNumber===l.endLineNumber?(f=M.endLineNumber,b=Math.max(M.endColumn,l.endColumn)):(f=l.endLineNumber,b=l.endColumn),new S(_,u,f,b)}intersectRanges(l){return S.intersectRanges(this,l)}static intersectRanges(l,M){let _=l.startLineNumber,u=l.startColumn,f=l.endLineNumber,b=l.endColumn,A=M.startLineNumber,v=M.startColumn,m=M.endLineNumber,e=M.endColumn;return _<A?(_=A,u=v):_===A&&(u=Math.max(u,v)),f>m?(f=m,b=e):f===m&&(b=Math.min(b,e)),_>f||_===f&&u>b?null:new S(_,u,f,b)}equalsRange(l){return S.equalsRange(this,l)}static equalsRange(l,M){return!!l&&!!M&&l.startLineNumber===M.startLineNumber&&l.startColumn===M.startColumn&&l.endLineNumber===M.endLineNumber&&l.endColumn===M.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(l){return new R.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(l){return new R.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,M){return new S(this.startLineNumber,this.startColumn,l,M)}setStartPosition(l,M){return new S(l,M,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(l){return new S(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,M=l){return new S(l.lineNumber,l.column,M.lineNumber,M.column)}static lift(l){return l?new S(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,M){return!(l.endLineNumber<M.startLineNumber||l.endLineNumber===M.startLineNumber&&l.endColumn<M.startColumn||M.endLineNumber<l.startLineNumber||M.endLineNumber===l.startLineNumber&&M.endColumn<l.startColumn)}static areIntersecting(l,M){return!(l.endLineNumber<M.startLineNumber||l.endLineNumber===M.startLineNumber&&l.endColumn<=M.startColumn||M.endLineNumber<l.startLineNumber||M.endLineNumber===l.startLineNumber&&M.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,M){if(l&&M){const f=l.startLineNumber|0,b=M.startLineNumber|0;if(f===b){const A=l.startColumn|0,v=M.startColumn|0;if(A===v){const m=l.endLineNumber|0,e=M.endLineNumber|0;if(m===e){const g=l.endColumn|0,N=M.endColumn|0;return g-N}return m-e}return A-v}return f-b}return(l?1:0)-(M?1:0)}static compareRangesUsingEnds(l,M){return l.endLineNumber===M.endLineNumber?l.endColumn===M.endColumn?l.startLineNumber===M.startLineNumber?l.startColumn-M.startColumn:l.startLineNumber-M.startLineNumber:l.endColumn-M.endColumn:l.endLineNumber-M.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}t.Range=S}),J(K[27],x([0,1,4,5]),function(U,t,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var D;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(D=t.SelectionDirection||(t.SelectionDirection={}));class l extends S.Range{constructor(_,u,f,b){super(_,u,f,b);this.selectionStartLineNumber=_,this.selectionStartColumn=u,this.positionLineNumber=f,this.positionColumn=b}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(_){return l.selectionsEqual(this,_)}static selectionsEqual(_,u){return _.selectionStartLineNumber===u.selectionStartLineNumber&&_.selectionStartColumn===u.selectionStartColumn&&_.positionLineNumber===u.positionLineNumber&&_.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(_,u){return this.getDirection()===0?new l(this.startLineNumber,this.startColumn,_,u):new l(_,u,this.startLineNumber,this.startColumn)}getPosition(){return new R.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new R.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(_,u){return this.getDirection()===0?new l(_,u,this.endLineNumber,this.endColumn):new l(this.endLineNumber,this.endColumn,_,u)}static fromPositions(_,u=_){return new l(_.lineNumber,_.column,u.lineNumber,u.column)}static fromRange(_,u){return u===0?new l(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):new l(_.endLineNumber,_.endColumn,_.startLineNumber,_.startColumn)}static liftSelection(_){return new l(_.selectionStartLineNumber,_.selectionStartColumn,_.positionLineNumber,_.positionColumn)}static selectionsArrEqual(_,u){if(_&&!u||!_&&u)return!1;if(!_&&!u)return!0;if(_.length!==u.length)return!1;for(let f=0,b=_.length;f<b;f++)if(!this.selectionsEqual(_[f],u[f]))return!1;return!0}static isISelection(_){return _&&typeof _.selectionStartLineNumber=="number"&&typeof _.selectionStartColumn=="number"&&typeof _.positionLineNumber=="number"&&typeof _.positionColumn=="number"}static createWithDirection(_,u,f,b,A){return A===0?new l(_,u,f,b):new l(f,b,_,u)}}t.Selection=l}),J(K[28],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class R{constructor(M,_,u){this._tokenBrand=void 0,this.offset=M,this.type=_,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=R;class S{constructor(M,_){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=_}}t.TokenizationResult=S;class D{constructor(M,_){this._tokenizationResult2Brand=void 0,this.tokens=M,this.endState=_}}t.TokenizationResult2=D}),J(K[29],x([0,1,12,3]),function(U,t,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const D=3;function l(g,N,L,w){return new R.LcsDiff(g,N,L).ComputeDiff(w)}class M{constructor(N){const L=[],w=[];for(let s=0,i=N.length;s<i;s++)L[s]=v(N[s],1),w[s]=m(N[s],1);this.lines=N,this._startColumns=L,this._endColumns=w}getElements(){const N=[];for(let L=0,w=this.lines.length;L<w;L++)N[L]=this.lines[L].substring(this._startColumns[L]-1,this._endColumns[L]-1);return N}getStrictElement(N){return this.lines[N]}getStartLineNumber(N){return N+1}getEndLineNumber(N){return N+1}createCharSequence(N,L,w){const s=[],i=[],r=[];let a=0;for(let d=L;d<=w;d++){const h=this.lines[d],o=N?this._startColumns[d]:1,c=N?this._endColumns[d]:h.length+1;for(let E=o;E<c;E++)s[a]=h.charCodeAt(E-1),i[a]=d+1,r[a]=E,a++}return new _(s,i,r)}}class _{constructor(N,L,w){this._charCodes=N,this._lineNumbers=L,this._columns=w}getElements(){return this._charCodes}getStartLineNumber(N){return this._lineNumbers[N]}getStartColumn(N){return this._columns[N]}getEndLineNumber(N){return this._lineNumbers[N]}getEndColumn(N){return this._columns[N]+1}}class u{constructor(N,L,w,s,i,r,a,d){this.originalStartLineNumber=N,this.originalStartColumn=L,this.originalEndLineNumber=w,this.originalEndColumn=s,this.modifiedStartLineNumber=i,this.modifiedStartColumn=r,this.modifiedEndLineNumber=a,this.modifiedEndColumn=d}static createFromDiffChange(N,L,w){let s,i,r,a,d,h,o,c;return N.originalLength===0?(s=0,i=0,r=0,a=0):(s=L.getStartLineNumber(N.originalStart),i=L.getStartColumn(N.originalStart),r=L.getEndLineNumber(N.originalStart+N.originalLength-1),a=L.getEndColumn(N.originalStart+N.originalLength-1)),N.modifiedLength===0?(d=0,h=0,o=0,c=0):(d=w.getStartLineNumber(N.modifiedStart),h=w.getStartColumn(N.modifiedStart),o=w.getEndLineNumber(N.modifiedStart+N.modifiedLength-1),c=w.getEndColumn(N.modifiedStart+N.modifiedLength-1)),new u(s,i,r,a,d,h,o,c)}}function f(g){if(g.length<=1)return g;const N=[g[0]];let L=N[0];for(let w=1,s=g.length;w<s;w++){const i=g[w],r=i.originalStart-(L.originalStart+L.originalLength),a=i.modifiedStart-(L.modifiedStart+L.modifiedLength);Math.min(r,a)<D?(L.originalLength=i.originalStart+i.originalLength-L.originalStart,L.modifiedLength=i.modifiedStart+i.modifiedLength-L.modifiedStart):(N.push(i),L=i)}return N}class b{constructor(N,L,w,s,i){this.originalStartLineNumber=N,this.originalEndLineNumber=L,this.modifiedStartLineNumber=w,this.modifiedEndLineNumber=s,this.charChanges=i}static createFromDiffResult(N,L,w,s,i,r,a){let d,h,o,c,E;if(L.originalLength===0?(d=w.getStartLineNumber(L.originalStart)-1,h=0):(d=w.getStartLineNumber(L.originalStart),h=w.getEndLineNumber(L.originalStart+L.originalLength-1)),L.modifiedLength===0?(o=s.getStartLineNumber(L.modifiedStart)-1,c=0):(o=s.getStartLineNumber(L.modifiedStart),c=s.getEndLineNumber(L.modifiedStart+L.modifiedLength-1)),r&&L.originalLength>0&&L.originalLength<20&&L.modifiedLength>0&&L.modifiedLength<20&&i()){const P=w.createCharSequence(N,L.originalStart,L.originalStart+L.originalLength-1),F=s.createCharSequence(N,L.modifiedStart,L.modifiedStart+L.modifiedLength-1);let I=l(P,F,i,!0).changes;a&&(I=f(I)),E=[];for(let k=0,W=I.length;k<W;k++)E.push(u.createFromDiffChange(I[k],P,F))}return new b(d,h,o,c,E)}}class A{constructor(N,L,w){this.shouldComputeCharChanges=w.shouldComputeCharChanges,this.shouldPostProcessCharChanges=w.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=w.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=w.shouldMakePrettyDiff,this.originalLines=N,this.modifiedLines=L,this.original=new M(N),this.modified=new M(L),this.continueLineDiff=e(w.maxComputationTime),this.continueCharDiff=e(w.maxComputationTime===0?0:Math.min(w.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const N=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),L=N.changes,w=N.quitEarly;if(this.shouldIgnoreTrimWhitespace){const a=[];for(let d=0,h=L.length;d<h;d++)a.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,L[d],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:w,changes:a}}const s=[];let i=0,r=0;for(let a=-1,d=L.length;a<d;a++){const h=a+1<d?L[a+1]:null,o=h?h.originalStart:this.originalLines.length,c=h?h.modifiedStart:this.modifiedLines.length;for(;i<o&&r<c;){const E=this.originalLines[i],P=this.modifiedLines[r];if(E!==P){{let F=v(E,1),I=v(P,1);for(;F>1&&I>1;){const k=E.charCodeAt(F-2),W=P.charCodeAt(I-2);if(k!==W)break;F--,I--}(F>1||I>1)&&this._pushTrimWhitespaceCharChange(s,i+1,1,F,r+1,1,I)}{let F=m(E,1),I=m(P,1);const k=E.length+1,W=P.length+1;for(;F<k&&I<W;){const q=E.charCodeAt(F-1),Q=E.charCodeAt(I-1);if(q!==Q)break;F++,I++}(F<k||I<W)&&this._pushTrimWhitespaceCharChange(s,i+1,F,k,r+1,I,W)}}i++,r++}h&&(s.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,h,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=h.originalLength,r+=h.modifiedLength)}return{quitEarly:w,changes:s}}_pushTrimWhitespaceCharChange(N,L,w,s,i,r,a){if(this._mergeTrimWhitespaceCharChange(N,L,w,s,i,r,a))return;let d;this.shouldComputeCharChanges&&(d=[new u(L,w,L,s,i,r,i,a)]),N.push(new b(L,L,i,i,d))}_mergeTrimWhitespaceCharChange(N,L,w,s,i,r,a){const d=N.length;if(d===0)return!1;const h=N[d-1];return h.originalEndLineNumber===0||h.modifiedEndLineNumber===0?!1:h.originalEndLineNumber+1===L&&h.modifiedEndLineNumber+1===i?(h.originalEndLineNumber=L,h.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&h.charChanges&&h.charChanges.push(new u(L,w,L,s,i,r,i,a)),!0):!1}}t.DiffComputer=A;function v(g,N){const L=S.firstNonWhitespaceIndex(g);return L===-1?N:L+1}function m(g,N){const L=S.lastNonWhitespaceIndex(g);return L===-1?N:L+2}function e(g){if(g===0)return()=>!0;const N=Date.now();return()=>Date.now()-N<g}}),J(K[30],x([0,1,25]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ApplyEditsResult=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.MinimapPosition=t.OverviewRulerLane=void 0;var S;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(S=t.OverviewRulerLane||(t.OverviewRulerLane={}));var D;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(D=t.MinimapPosition||(t.MinimapPosition={}));var l;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(l=t.EndOfLinePreference||(t.EndOfLinePreference={}));var M;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(M=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var _;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(_=t.EndOfLineSequence||(t.EndOfLineSequence={}));class u{constructor(N){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,N.tabSize|0),this.indentSize=N.tabSize|0,this.insertSpaces=Boolean(N.insertSpaces),this.defaultEOL=N.defaultEOL|0,this.trimAutoWhitespace=Boolean(N.trimAutoWhitespace),this.bracketPairColorizationOptions=N.bracketPairColorizationOptions}equals(N){return this.tabSize===N.tabSize&&this.indentSize===N.indentSize&&this.insertSpaces===N.insertSpaces&&this.defaultEOL===N.defaultEOL&&this.trimAutoWhitespace===N.trimAutoWhitespace&&(0,R.equals)(this.bracketPairColorizationOptions,N.bracketPairColorizationOptions)}createChangeEvent(N){return{tabSize:this.tabSize!==N.tabSize,indentSize:this.indentSize!==N.indentSize,insertSpaces:this.insertSpaces!==N.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==N.trimAutoWhitespace}}}t.TextModelResolvedOptions=u;class f{constructor(N,L){this._findMatchBrand=void 0,this.range=N,this.matches=L}}t.FindMatch=f;var b;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var A;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None"})(A=t.PositionAffinity||(t.PositionAffinity={}));var v;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=t.ModelConstants||(t.ModelConstants={}));class m{constructor(N,L,w,s,i,r){this.identifier=N,this.range=L,this.text=w,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=i,this._isTracked=r}}t.ValidAnnotatedEditOperation=m;class e{constructor(N,L,w){this.reverseEdits=N,this.changes=L,this.trimAutoWhitespaceLineNumbers=w}}t.ApplyEditsResult=e}),J(K[31],x([0,1,3,26,4,5,30]),function(U,t,R,S,D,l,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.SearchData=t.isMultilineRegexSource=t.SearchParams=void 0;const _=999;class u{constructor(s,i,r,a){this.searchString=s,this.isRegex=i,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=f(this.searchString):s=this.searchString.indexOf(`
`)>=0;let i=null;try{i=R.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(a){return null}if(!i)return null;let r=!this.isRegex&&!s;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new b(i,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,r?this.searchString:null)}}t.SearchParams=u;function f(w){if(!w||w.length===0)return!1;for(let s=0,i=w.length;s<i;s++)if(w.charCodeAt(s)===92){if(s++,s>=i)break;const a=w.charCodeAt(s);if(a===110||a===114||a===87)return!0}return!1}t.isMultilineRegexSource=f;class b{constructor(s,i,r){this.regex=s,this.wordSeparators=i,this.simpleSearch=r}}t.SearchData=b;function A(w,s,i){if(!i)return new M.FindMatch(w,null);let r=[];for(let a=0,d=s.length;a<d;a++)r[a]=s[a];return new M.FindMatch(w,r)}t.createFindMatch=A;class v{constructor(s){let i=[],r=0;for(let a=0,d=s.length;a<d;a++)s.charCodeAt(a)===10&&(i[r++]=a);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(s){const i=this._lineFeedsOffsets;let r=0,a=i.length-1;if(a===-1||s<=i[0])return 0;for(;r<a;){const d=r+((a-r)/2>>0);i[d]>=s?a=d-1:i[d+1]>=s?(r=d,a=d):r=d+1}return r+1}}class m{static findMatches(s,i,r,a,d){const h=i.parseSearchRequest();return h?h.regex.multiline?this._doFindMatchesMultiline(s,r,new L(h.wordSeparators,h.regex),a,d):this._doFindMatchesLineByLine(s,r,h,a,d):[]}static _getMultilineMatchRange(s,i,r,a,d,h){let o,c=0;a?(c=a.findLineFeedCountBeforeOffset(d),o=i+d+c):o=i+d;let E;if(a){let k=a.findLineFeedCountBeforeOffset(d+h.length)-c;E=o+h.length+k}else E=o+h.length;const P=s.getPositionAt(o),F=s.getPositionAt(E);return new l.Range(P.lineNumber,P.column,F.lineNumber,F.column)}static _doFindMatchesMultiline(s,i,r,a,d){const h=s.getOffsetAt(i.getStartPosition()),o=s.getValueInRange(i,1),c=s.getEOL()===`\r
`?new v(o):null,E=[];let P=0,F;for(r.reset(0);F=r.next(o);)if(E[P++]=A(this._getMultilineMatchRange(s,h,o,c,F.index,F[0]),F,a),P>=d)return E;return E}static _doFindMatchesLineByLine(s,i,r,a,d){const h=[];let o=0;if(i.startLineNumber===i.endLineNumber){const E=s.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return o=this._findMatchesInLine(r,E,i.startLineNumber,i.startColumn-1,o,h,a,d),h}const c=s.getLineContent(i.startLineNumber).substring(i.startColumn-1);o=this._findMatchesInLine(r,c,i.startLineNumber,i.startColumn-1,o,h,a,d);for(let E=i.startLineNumber+1;E<i.endLineNumber&&o<d;E++)o=this._findMatchesInLine(r,s.getLineContent(E),E,0,o,h,a,d);if(o<d){const E=s.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);o=this._findMatchesInLine(r,E,i.endLineNumber,0,o,h,a,d)}return h}static _findMatchesInLine(s,i,r,a,d,h,o,c){const E=s.wordSeparators;if(!o&&s.simpleSearch){const I=s.simpleSearch,k=I.length,W=i.length;let q=-k;for(;(q=i.indexOf(I,q+k))!==-1;)if((!E||N(E,i,W,q,k))&&(h[d++]=new M.FindMatch(new l.Range(r,q+1+a,r,q+1+k+a),null),d>=c))return d;return d}const P=new L(s.wordSeparators,s.regex);let F;P.reset(0);do if(F=P.next(i),F&&(h[d++]=A(new l.Range(r,F.index+1+a,r,F.index+1+F[0].length+a),F,o),d>=c))return d;while(F);return d}static findNextMatch(s,i,r,a){const d=i.parseSearchRequest();if(!d)return null;const h=new L(d.wordSeparators,d.regex);return d.regex.multiline?this._doFindNextMatchMultiline(s,r,h,a):this._doFindNextMatchLineByLine(s,r,h,a)}static _doFindNextMatchMultiline(s,i,r,a){const d=new D.Position(i.lineNumber,1),h=s.getOffsetAt(d),o=s.getLineCount(),c=s.getValueInRange(new l.Range(d.lineNumber,d.column,o,s.getLineMaxColumn(o)),1),E=s.getEOL()===`\r
`?new v(c):null;r.reset(i.column-1);let P=r.next(c);return P?A(this._getMultilineMatchRange(s,h,c,E,P.index,P[0]),P,a):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(s,new D.Position(1,1),r,a):null}static _doFindNextMatchLineByLine(s,i,r,a){const d=s.getLineCount(),h=i.lineNumber,o=s.getLineContent(h),c=this._findFirstMatchInLine(r,o,h,i.column,a);if(c)return c;for(let E=1;E<=d;E++){const P=(h+E-1)%d,F=s.getLineContent(P+1),I=this._findFirstMatchInLine(r,F,P+1,1,a);if(I)return I}return null}static _findFirstMatchInLine(s,i,r,a,d){s.reset(a-1);const h=s.next(i);return h?A(new l.Range(r,h.index+1,r,h.index+1+h[0].length),h,d):null}static findPreviousMatch(s,i,r,a){const d=i.parseSearchRequest();if(!d)return null;const h=new L(d.wordSeparators,d.regex);return d.regex.multiline?this._doFindPreviousMatchMultiline(s,r,h,a):this._doFindPreviousMatchLineByLine(s,r,h,a)}static _doFindPreviousMatchMultiline(s,i,r,a){const d=this._doFindMatchesMultiline(s,new l.Range(1,1,i.lineNumber,i.column),r,a,10*_);if(d.length>0)return d[d.length-1];const h=s.getLineCount();return i.lineNumber!==h||i.column!==s.getLineMaxColumn(h)?this._doFindPreviousMatchMultiline(s,new D.Position(h,s.getLineMaxColumn(h)),r,a):null}static _doFindPreviousMatchLineByLine(s,i,r,a){const d=s.getLineCount(),h=i.lineNumber,o=s.getLineContent(h).substring(0,i.column-1),c=this._findLastMatchInLine(r,o,h,a);if(c)return c;for(let E=1;E<=d;E++){const P=(d+h-E-1)%d,F=s.getLineContent(P+1),I=this._findLastMatchInLine(r,F,P+1,a);if(I)return I}return null}static _findLastMatchInLine(s,i,r,a){let d=null,h;for(s.reset(0);h=s.next(i);)d=A(new l.Range(r,h.index+1,r,h.index+1+h[0].length),h,a);return d}}t.TextModelSearch=m;function e(w,s,i,r,a){if(r===0)return!0;const d=s.charCodeAt(r-1);if(w.get(d)!==0||d===13||d===10)return!0;if(a>0){const h=s.charCodeAt(r);if(w.get(h)!==0)return!0}return!1}function g(w,s,i,r,a){if(r+a===i)return!0;const d=s.charCodeAt(r+a);if(w.get(d)!==0||d===13||d===10)return!0;if(a>0){const h=s.charCodeAt(r+a-1);if(w.get(h)!==0)return!0}return!1}function N(w,s,i,r,a){return e(w,s,i,r,a)&&g(w,s,i,r,a)}t.isValidMatch=N;class L{constructor(s,i){this._wordSeparators=s,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const i=s.length;let r;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(r=this._searchRegex.exec(s),!r))return null;const a=r.index,d=r[0].length;if(a===this._prevMatchStartIndex&&d===this._prevMatchLength){if(d===0){R.getNextCodePoint(s,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=d,!this._wordSeparators||N(this._wordSeparators,s,i,a,d))return r}while(r);return null}}t.Searcher=L}),J(K[32],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(_=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const f of t.USUAL_WORD_SEPARATORS)_.indexOf(f)>=0||(u+="\\"+f);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=R();function S(_){let u=t.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)u=_;else{let f="g";_.ignoreCase&&(f+="i"),_.multiline&&(f+="m"),_.unicode&&(f+="u"),u=new RegExp(_.source,f)}return u.lastIndex=0,u}t.ensureValidWordDefinition=S;const D={maxLen:1e3,windowSize:15,timeBudget:150};function l(_,u,f,b,A=D){if(f.length>A.maxLen){let N=_-A.maxLen/2;return N<0?N=0:b+=N,f=f.substring(N,_+A.maxLen/2),l(_,u,f,b,A)}const v=Date.now(),m=_-1-b;let e=-1,g=null;for(let N=1;!(Date.now()-v>=A.timeBudget);N++){const L=m-A.windowSize*N;u.lastIndex=Math.max(0,L);const w=M(u,f,m,e);if(!w&&g||(g=w,L<=0))break;e=L}if(g){let N={word:g[0],startColumn:b+1+g.index,endColumn:b+1+g.index+g[0].length};return u.lastIndex=0,N}return null}t.getWordAtText=l;function M(_,u,f,b){let A;for(;A=_.exec(u);){const v=A.index||0;if(v<=f&&_.lastIndex>=f)return A;if(b>0&&v>b)return null}return null}}),J(K[33],x([0,1,15]),function(U,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var S;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(S=t.State||(t.State={}));class D{constructor(e,g,N){const L=new Uint8Array(e*g);for(let w=0,s=e*g;w<s;w++)L[w]=N;this._data=L,this.rows=e,this.cols=g}get(e,g){return this._data[e*this.cols+g]}set(e,g,N){this._data[e*this.cols+g]=N}}t.Uint8Matrix=D;class l{constructor(e){let g=0,N=0;for(let w=0,s=e.length;w<s;w++){let[i,r,a]=e[w];r>g&&(g=r),i>N&&(N=i),a>N&&(N=a)}g++,N++;let L=new D(N,g,0);for(let w=0,s=e.length;w<s;w++){let[i,r,a]=e[w];L.set(i,r,a)}this._states=L,this._maxCharCode=g}nextState(e,g){return g<0||g>=this._maxCharCode?0:this._states.get(e,g)}}t.StateMachine=l;let M=null;function _(){return M===null&&(M=new l([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var u;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let f=null;function b(){if(f===null){f=new R.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<m.length;g++)f.set(m.charCodeAt(g),1);const e=".,;";for(let g=0;g<e.length;g++)f.set(e.charCodeAt(g),2)}return f}class A{static _createLink(e,g,N,L,w){let s=w-1;do{const i=g.charCodeAt(s);if(e.get(i)!==2)break;s--}while(s>L);if(L>0){const i=g.charCodeAt(L-1),r=g.charCodeAt(s);(i===40&&r===41||i===91&&r===93||i===123&&r===125)&&s--}return{range:{startLineNumber:N,startColumn:L+1,endLineNumber:N,endColumn:s+2},url:g.substring(L,s+1)}}static computeLinks(e,g=_()){const N=b();let L=[];for(let w=1,s=e.getLineCount();w<=s;w++){const i=e.getLineContent(w),r=i.length;let a=0,d=0,h=0,o=1,c=!1,E=!1,P=!1,F=!1;for(;a<r;){let I=!1;const k=i.charCodeAt(a);if(o===13){let W;switch(k){case 40:c=!0,W=0;break;case 41:W=c?0:1;break;case 91:P=!0,E=!0,W=0;break;case 93:P=!1,W=E?0:1;break;case 123:F=!0,W=0;break;case 125:W=F?0:1;break;case 39:W=h===34||h===96?0:1;break;case 34:W=h===39||h===96?0:1;break;case 96:W=h===39||h===34?0:1;break;case 42:W=h===42?1:0;break;case 124:W=h===124?1:0;break;case 32:W=P?0:1;break;default:W=N.get(k)}W===1&&(L.push(A._createLink(N,i,w,d,a)),I=!0)}else if(o===12){let W;k===91?(E=!0,W=0):W=N.get(k),W===1?I=!0:o=13}else o=g.nextState(o,k),o===0&&(I=!0);I&&(o=1,c=!1,E=!1,F=!1,d=a+1,h=k),a++}o===13&&L.push(A._createLink(N,i,w,d,r))}return L}}t.LinkComputer=A;function v(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:A.computeLinks(m)}t.computeLinks=v}),J(K[34],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class R{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(D,l,M,_,u){if(D&&l){let f=this.doNavigateValueSet(l,u);if(f)return{range:D,value:f}}if(M&&_){let f=this.doNavigateValueSet(_,u);if(f)return{range:M,value:f}}return null}doNavigateValueSet(D,l){let M=this.numberReplace(D,l);return M!==null?M:this.textReplace(D,l)}numberReplace(D,l){let M=Math.pow(10,D.length-(D.lastIndexOf(".")+1)),_=Number(D),u=parseFloat(D);return!isNaN(_)&&!isNaN(u)&&_===u?_===0&&!l?null:(_=Math.floor(_*M),_+=l?M:-M,String(_/M)):null}textReplace(D,l){return this.valueSetsReplace(this._defaultValueSet,D,l)}valueSetsReplace(D,l,M){let _=null;for(let u=0,f=D.length;_===null&&u<f;u++)_=this.valueSetReplace(D[u],l,M);return _}valueSetReplace(D,l,M){let _=D.indexOf(l);return _>=0?(_+=M?1:-1,_<0?_=D.length-1:_%=D.length,D[_]):null}}t.BasicInplaceReplace=R,R.INSTANCE=new R}),J(K[35],x([0,1,5,31,3,6]),function(U,t,R,S,D,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class M{static computeUnicodeHighlights(v,m,e){const g=e?e.startLineNumber:1,N=e?e.endLineNumber:v.getLineCount(),L=new f(m),w=L.getCandidateCodePoints();let s;w==="allNonBasicAscii"?s=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):s=new RegExp(`${_(Array.from(w))}`,"g");const i=new S.Searcher(null,s),r=[];let a=!1,d,h=0,o=0,c=0;e:for(let E=g,P=N;E<=P;E++){const F=v.getLineContent(E),I=F.length;i.reset(0);do if(d=i.next(F),d){let k=d.index,W=d.index+d[0].length;if(k>0){const G=F.charCodeAt(k-1);D.isHighSurrogate(G)&&k--}if(W+1<I){const G=F.charCodeAt(W-1);D.isHighSurrogate(G)&&W++}const q=F.substring(k,W),Q=L.shouldHighlightNonBasicASCII(q);if(Q!==0){Q===3?h++:Q===2?o++:Q===1?c++:(0,l.assertNever)(Q);const G=1e3;if(r.length>=G){a=!0;break e}r.push(new R.Range(E,k+1,E,W+1))}}while(d)}return{ranges:r,hasMore:a,ambiguousCharacterCount:h,invisibleCharacterCount:o,nonBasicAsciiCharacterCount:c}}static computeUnicodeHighlightReason(v,m){switch(new f(m).shouldHighlightNonBasicASCII(v)){case 0:return null;case 2:return{kind:1};case 3:const N=D.AmbiguousCharacters.getPrimaryConfusable(v.codePointAt(0));return{kind:0,confusableWith:String.fromCodePoint(N)};case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=M;function _(A,v){return`[${D.escapeRegExpCharacters(A.map(e=>String.fromCodePoint(e)).join(""))}]`}var u;(function(A){A[A.Ambiguous=0]="Ambiguous",A[A.Invisible=1]="Invisible",A[A.NonBasicAscii=2]="NonBasicAscii"})(u=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class f{constructor(v){this.options=v,this.allowedCodePoints=new Set(v.allowedCodePoints)}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const v=new Set;if(this.options.invisibleCharacters)for(const m of D.InvisibleCharacters.codePoints)v.add(m);if(this.options.ambiguousCharacters)for(const m of D.AmbiguousCharacters.getPrimaryConfusableCodePoints())v.add(m);for(const m of this.allowedCodePoints)v.delete(m);return v}shouldHighlightNonBasicASCII(v){const m=v.codePointAt(0);return this.allowedCodePoints.has(m)?0:this.options.nonBasicASCII?1:this.options.invisibleCharacters&&!(v===" "||v===`
`||v==="	")&&D.InvisibleCharacters.isInvisibleCharacter(m)?2:this.options.ambiguousCharacters&&D.AmbiguousCharacters.isAmbiguous(m)?3:0}}var b;(function(A){A[A.None=0]="None",A[A.NonBasicASCII=1]="NonBasicASCII",A[A.Invisible=2]="Invisible",A[A.Ambiguous=3]="Ambiguous"})(b||(b={}))}),J(K[36],x([0,1]),function(U,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var R;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(R=t.AccessibilitySupport||(t.AccessibilitySupport={}));var S;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(S=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var D;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(D=t.CompletionItemKind||(t.CompletionItemKind={}));var l;(function(n){n[n.Deprecated=1]="Deprecated"})(l=t.CompletionItemTag||(t.CompletionItemTag={}));var M;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(M=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var _;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(_=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var f;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(f=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var b;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(b=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var A;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(A=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var v;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.columnSelection=18]="columnSelection",n[n.comments=19]="comments",n[n.contextmenu=20]="contextmenu",n[n.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",n[n.cursorBlinking=22]="cursorBlinking",n[n.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",n[n.cursorStyle=24]="cursorStyle",n[n.cursorSurroundingLines=25]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",n[n.cursorWidth=27]="cursorWidth",n[n.disableLayerHinting=28]="disableLayerHinting",n[n.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",n[n.domReadOnly=30]="domReadOnly",n[n.dragAndDrop=31]="dragAndDrop",n[n.emptySelectionClipboard=32]="emptySelectionClipboard",n[n.extraEditorClassName=33]="extraEditorClassName",n[n.fastScrollSensitivity=34]="fastScrollSensitivity",n[n.find=35]="find",n[n.fixedOverflowWidgets=36]="fixedOverflowWidgets",n[n.folding=37]="folding",n[n.foldingStrategy=38]="foldingStrategy",n[n.foldingHighlight=39]="foldingHighlight",n[n.foldingImportsByDefault=40]="foldingImportsByDefault",n[n.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=42]="fontFamily",n[n.fontInfo=43]="fontInfo",n[n.fontLigatures=44]="fontLigatures",n[n.fontSize=45]="fontSize",n[n.fontWeight=46]="fontWeight",n[n.formatOnPaste=47]="formatOnPaste",n[n.formatOnType=48]="formatOnType",n[n.glyphMargin=49]="glyphMargin",n[n.gotoLocation=50]="gotoLocation",n[n.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",n[n.hover=52]="hover",n[n.inDiffEditor=53]="inDiffEditor",n[n.inlineSuggest=54]="inlineSuggest",n[n.letterSpacing=55]="letterSpacing",n[n.lightbulb=56]="lightbulb",n[n.lineDecorationsWidth=57]="lineDecorationsWidth",n[n.lineHeight=58]="lineHeight",n[n.lineNumbers=59]="lineNumbers",n[n.lineNumbersMinChars=60]="lineNumbersMinChars",n[n.linkedEditing=61]="linkedEditing",n[n.links=62]="links",n[n.matchBrackets=63]="matchBrackets",n[n.minimap=64]="minimap",n[n.mouseStyle=65]="mouseStyle",n[n.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=67]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",n[n.multiCursorModifier=69]="multiCursorModifier",n[n.multiCursorPaste=70]="multiCursorPaste",n[n.occurrencesHighlight=71]="occurrencesHighlight",n[n.overviewRulerBorder=72]="overviewRulerBorder",n[n.overviewRulerLanes=73]="overviewRulerLanes",n[n.padding=74]="padding",n[n.parameterHints=75]="parameterHints",n[n.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",n[n.quickSuggestions=78]="quickSuggestions",n[n.quickSuggestionsDelay=79]="quickSuggestionsDelay",n[n.readOnly=80]="readOnly",n[n.renameOnType=81]="renameOnType",n[n.renderControlCharacters=82]="renderControlCharacters",n[n.renderFinalNewline=83]="renderFinalNewline",n[n.renderLineHighlight=84]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=86]="renderValidationDecorations",n[n.renderWhitespace=87]="renderWhitespace",n[n.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",n[n.roundedSelection=89]="roundedSelection",n[n.rulers=90]="rulers",n[n.scrollbar=91]="scrollbar",n[n.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=93]="scrollBeyondLastLine",n[n.scrollPredominantAxis=94]="scrollPredominantAxis",n[n.selectionClipboard=95]="selectionClipboard",n[n.selectionHighlight=96]="selectionHighlight",n[n.selectOnLineNumbers=97]="selectOnLineNumbers",n[n.showFoldingControls=98]="showFoldingControls",n[n.showUnused=99]="showUnused",n[n.snippetSuggestions=100]="snippetSuggestions",n[n.smartSelect=101]="smartSelect",n[n.smoothScrolling=102]="smoothScrolling",n[n.stickyTabStops=103]="stickyTabStops",n[n.stopRenderingLineAfter=104]="stopRenderingLineAfter",n[n.suggest=105]="suggest",n[n.suggestFontSize=106]="suggestFontSize",n[n.suggestLineHeight=107]="suggestLineHeight",n[n.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",n[n.suggestSelection=109]="suggestSelection",n[n.tabCompletion=110]="tabCompletion",n[n.tabIndex=111]="tabIndex",n[n.unicodeHighlighting=112]="unicodeHighlighting",n[n.unusualLineTerminators=113]="unusualLineTerminators",n[n.useShadowDOM=114]="useShadowDOM",n[n.useTabStops=115]="useTabStops",n[n.wordSeparators=116]="wordSeparators",n[n.wordWrap=117]="wordWrap",n[n.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=120]="wordWrapColumn",n[n.wordWrapOverride1=121]="wordWrapOverride1",n[n.wordWrapOverride2=122]="wordWrapOverride2",n[n.wrappingIndent=123]="wrappingIndent",n[n.wrappingStrategy=124]="wrappingStrategy",n[n.showDeprecated=125]="showDeprecated",n[n.inlayHints=126]="inlayHints",n[n.editorClassName=127]="editorClassName",n[n.pixelRatio=128]="pixelRatio",n[n.tabFocusMode=129]="tabFocusMode",n[n.layoutInfo=130]="layoutInfo",n[n.wrappingInfo=131]="wrappingInfo"})(v=t.EditorOption||(t.EditorOption={}));var m;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(m=t.EndOfLinePreference||(t.EndOfLinePreference={}));var e;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(e=t.EndOfLineSequence||(t.EndOfLineSequence={}));var g;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(g=t.IndentAction||(t.IndentAction={}));var N;(function(n){n[n.Other=0]="Other",n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(N=t.InlayHintKind||(t.InlayHintKind={}));var L;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(L=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var w;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.MAX_VALUE=126]="MAX_VALUE"})(w=t.KeyCode||(t.KeyCode={}));var s;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(s=t.MarkerSeverity||(t.MarkerSeverity={}));var i;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(i=t.MarkerTag||(t.MarkerTag={}));var r;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(r=t.MinimapPosition||(t.MinimapPosition={}));var a;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(a=t.MouseTargetType||(t.MouseTargetType={}));var d;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(d=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var h;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(h=t.OverviewRulerLane||(t.OverviewRulerLane={}));var o;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(o=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var c;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(c=t.RenderMinimap||(t.RenderMinimap={}));var E;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(E=t.ScrollType||(t.ScrollType={}));var P;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(P=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var F;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(F=t.SelectionDirection||(t.SelectionDirection={}));var I;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(I=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var k;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(k=t.SymbolKind||(t.SymbolKind={}));var W;(function(n){n[n.Deprecated=1]="Deprecated"})(W=t.SymbolTag||(t.SymbolTag={}));var q;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(q=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var Q;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(Q=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var G;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var ue;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ue=t.WrappingIndent||(t.WrappingIndent={}))}),J(K[37],x([0,1,23,8,19,14,4,5,27,28,36]),function(U,t,R,S,D,l,M,_,u,f,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class A{static chord(e,g){return(0,D.KeyChord)(e,g)}}t.KeyMod=A,A.CtrlCmd=2048,A.Shift=1024,A.Alt=512,A.WinCtrl=256;function v(){return{editor:void 0,languages:void 0,CancellationTokenSource:R.CancellationTokenSource,Emitter:S.Emitter,KeyCode:b.KeyCode,KeyMod:A,Position:M.Position,Range:_.Range,Selection:u.Selection,SelectionDirection:b.SelectionDirection,MarkerSeverity:b.MarkerSeverity,MarkerTag:b.MarkerTag,Uri:l.URI,Token:f.Token}}t.createMonacoBaseAPI=v}),J(K[38],x([0,1,17,13]),function(U,t,R,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class D{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(u,f){u=(0,S.toUint32)(u);const b=this.values,A=this.prefixSum,v=f.length;return v===0?!1:(this.values=new Uint32Array(b.length+v),this.values.set(b.subarray(0,u),0),this.values.set(b.subarray(u),u+v),this.values.set(f,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,f){return u=(0,S.toUint32)(u),f=(0,S.toUint32)(f),this.values[u]===f?!1:(this.values[u]=f,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,f){u=(0,S.toUint32)(u),f=(0,S.toUint32)(f);const b=this.values,A=this.prefixSum;if(u>=b.length)return!1;let v=b.length-u;return f>=v&&(f=v),f===0?!1:(this.values=new Uint32Array(b.length-f),this.values.set(b.subarray(0,u),0),this.values.set(b.subarray(u+f),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,S.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let f=this.prefixSumValidIndex[0]+1;f===0&&(this.prefixSum[0]=this.values[0],f++),u>=this.values.length&&(u=this.values.length-1);for(let b=f;b<=u;b++)this.prefixSum[b]=this.prefixSum[b-1]+this.values[b];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let f=0,b=this.values.length-1,A=0,v=0,m=0;for(;f<=b;)if(A=f+(b-f)/2|0,v=this.prefixSum[A],m=v-this.values[A],u<m)b=A-1;else if(u>=v)f=A+1;else break;return new M(A,u-m)}}t.PrefixSumComputer=D;class l{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const f=this._indexBySum[u],b=f>0?this._prefixSum[f-1]:0;return new M(f,u-b)}removeValues(u,f){this._values.splice(u,f),this._invalidate(u)}insertValues(u,f){this._values=(0,R.arrayInsert)(this._values,u,f),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,f=this._values.length;u<f;u++){const b=this._values[u],A=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=A+b;for(let v=0;v<b;v++)this._indexBySum[A+v]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,f){this._values[u]!==f&&(this._values[u]=f,this._invalidate(u))}}t.ConstantTimePrefixSumComputer=l;class M{constructor(u,f){this.index=u,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=f}}t.PrefixSumIndexOfResult=M}),J(K[39],x([0,1,3,4,38]),function(U,t,R,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class l{constructor(_,u,f,b){this._uri=_,this._lines=u,this._eol=f,this._versionId=b,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const u=_.changes;for(const f of u)this._acceptDeleteRange(f.range),this._acceptInsertText(new S.Position(f.range.startLineNumber,f.range.startColumn),f.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,u=this._lines.length,f=new Uint32Array(u);for(let b=0;b<u;b++)f[b]=this._lines[b].length+_;this._lineStarts=new D.PrefixSumComputer(f)}}_setLineText(_,u){this._lines[_]=u,this._lineStarts&&this._lineStarts.setValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,u){if(u.length===0)return;let f=(0,R.splitLines)(u);if(f.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+f[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}f[f.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+f[0]);let b=new Uint32Array(f.length-1);for(let A=1;A<f.length;A++)this._lines.splice(_.lineNumber+A-1,0,f[A]),b[A-1]=f[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,b)}}t.MirrorTextModel=l}),J(K[41],x([0,1,12,2,14,4,5,29,39,32,33,34,37,6,11,35]),function(U,t,R,S,D,l,M,_,u,f,b,A,v,m,e,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=t.MirrorModel=void 0;class N extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let a=(0,f.getWordAtText)(i.column,(0,f.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return a?new M.Range(i.lineNumber,a.startColumn,i.lineNumber,a.endColumn):null}getWordUntilPosition(i,r){const a=this.getWordAtPosition(i,r);return a?{word:this._lines[i.lineNumber-1].substring(a.startColumn-1,i.column-1),startColumn:a.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,a=this._wordenize.bind(this);let d=0,h="",o=0,c=[];return{*[Symbol.iterator](){for(;;)if(o<c.length){const E=h.substring(c[o].start,c[o].end);o+=1,yield E}else if(d<r.length)h=r[d],c=a(h,i),o=0,d+=1;else break}}}getLineWords(i,r){let a=this._lines[i-1],d=this._wordenize(a,r),h=[];for(const o of d)h.push({word:a.substring(o.start,o.end),startColumn:o.start+1,endColumn:o.end+1});return h}_wordenize(i,r){const a=[];let d;for(r.lastIndex=0;(d=r.exec(i))&&d[0].length!==0;)a.push({start:d.index,end:d.index+d[0].length});return a}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,a=i.startLineNumber-1,d=i.endLineNumber-1,h=[];h.push(this._lines[a].substring(i.startColumn-1));for(let o=a+1;o<d;o++)h.push(this._lines[o]);return h.push(this._lines[d].substring(0,i.endColumn-1)),h.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),a=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,a)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),a=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||a.lineNumber!==i.endLineNumber||a.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:a.lineNumber,endColumn:a.column}:i}_validatePosition(i){if(!l.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:a}=i,d=!1;if(r<1)r=1,a=1,d=!0;else if(r>this._lines.length)r=this._lines.length,a=this._lines[r-1].length+1,d=!0;else{let h=this._lines[r-1].length+1;a<1?(a=1,d=!0):a>h&&(a=h,d=!0)}return d?{lineNumber:r,column:a}:i}}t.MirrorModel=N;class L{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new N(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeUnicodeHighlights(i,r,a){const d=this._getModel(i);return d?g.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,r,a):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,r,a,d){const h=this._getModel(i),o=this._getModel(r);if(!h||!o)return null;const c=h.getLinesContent(),E=o.getLinesContent(),F=new _.DiffComputer(c,E,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:a,shouldMakePrettyDiff:!0,maxComputationTime:d}).computeDiff(),I=F.changes.length>0?!1:this._modelsAreIdentical(h,o);return{quitEarly:F.quitEarly,identical:I,changes:F.changes}}_modelsAreIdentical(i,r){const a=i.getLineCount(),d=r.getLineCount();if(a!==d)return!1;for(let h=1;h<=a;h++){const o=i.getLineContent(h),c=r.getLineContent(h);if(o!==c)return!1}return!0}async computeDirtyDiff(i,r,a){let d=this._getModel(i),h=this._getModel(r);if(!d||!h)return null;let o=d.getLinesContent(),c=h.getLinesContent();return new _.DiffComputer(o,c,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:a,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const a=this._getModel(i);if(!a)return r;const d=[];let h;r=r.slice(0).sort((o,c)=>{if(o.range&&c.range)return M.Range.compareRangesUsingStarts(o.range,c.range);let E=o.range?0:1,P=c.range?0:1;return E-P});for(let{range:o,text:c,eol:E}of r){if(typeof E=="number"&&(h=E),M.Range.isEmpty(o)&&!c)continue;const P=a.getValueInRange(o);if(c=c.replace(/\r\n|\n|\r/g,a.eol),P===c)continue;if(Math.max(c.length,P.length)>L._diffLimit){d.push({range:o,text:c});continue}const F=(0,R.stringDiff)(P,c,!1),I=a.offsetAt(M.Range.lift(o).getStartPosition());for(const k of F){const W=a.positionAt(I+k.originalStart),q=a.positionAt(I+k.originalStart+k.originalLength),Q={text:c.substr(k.modifiedStart,k.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:q.lineNumber,endColumn:q.column}};a.getValueInRange(Q.range)!==Q.text&&d.push(Q)}}return typeof h=="number"&&d.push({eol:h,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d}async computeLinks(i){let r=this._getModel(i);return r?(0,b.computeLinks)(r):null}async textualSuggest(i,r,a,d){const h=new e.StopWatch(!0),o=new RegExp(a,d),c=new Set;e:for(let E of i){const P=this._getModel(E);if(!!P){for(let F of P.words(o))if(!(F===r||!isNaN(Number(F)))&&(c.add(F),c.size>L._suggestionsLimit))break e}}return{words:Array.from(c),duration:h.elapsed()}}async computeWordRanges(i,r,a,d){let h=this._getModel(i);if(!h)return Object.create(null);const o=new RegExp(a,d),c=Object.create(null);for(let E=r.startLineNumber;E<r.endLineNumber;E++){let P=h.getLineWords(E,o);for(const F of P){if(!isNaN(Number(F.word)))continue;let I=c[F.word];I||(I=[],c[F.word]=I),I.push({startLineNumber:E,startColumn:F.startColumn,endLineNumber:E,endColumn:F.endColumn})}}return c}async navigateValueSet(i,r,a,d,h){let o=this._getModel(i);if(!o)return null;let c=new RegExp(d,h);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let E=o.getValueInRange(r),P=o.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},c);if(!P)return null;let F=o.getValueInRange(P);return A.BasicInplaceReplace.INSTANCE.navigateValueSet(r,E,P,F,a)}loadForeignModule(i,r,a){const d=(c,E)=>this._host.fhr(c,E);let o={host:m.createProxyObject(a,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(o,r),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((c,E)=>{U([i],P=>{this._foreignModule=P.create(o,r),c(m.getAllMethodNames(this._foreignModule))},E)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(a){return Promise.reject(a)}}}t.EditorSimpleWorker=L,L._diffLimit=1e5,L._suggestionsLimit=1e4;function w(s){return new L(s,null)}t.create=w,typeof importScripts=="function"&&(S.globals.monaco=(0,v.createMonacoBaseAPI)())}),function(){const U=self.MonacoEnvironment,t=U&&U.baseUrl?U.baseUrl:"../../../",R=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:u=>u,createScript:(u,...f)=>{const b=f.slice(0,-1).join(","),A=f.pop().toString();return`(function anonymous(${b}) {
${A}
})`}}):void 0;function S(){try{return(R?self.eval(R.createScript("","true")):new Function("true")).call(self),!0}catch(u){return!1}}function D(){return new Promise((u,f)=>{if(typeof self.define=="function"&&self.define.amd)return u();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,self.origin.length)!==self.origin)&&S()){fetch(b).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${b}`,(R?self.eval(R.createScript("",v)):new Function(v)).call(self),u()}).then(void 0,f);return}R?importScripts(R.createScriptURL(b)):importScripts(b),u()})}const l=function(u){D().then(()=>{require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:R,amdModulesPattern:/^vs\//}),require([u],function(f){setTimeout(function(){let b=f.create((A,v)=>{self.postMessage(A,v)},null);for(self.onmessage=A=>b.onmessage(A.data,A.ports);_.length>0;)self.onmessage(_.shift())},0)})})};let M=!0,_=[];self.onmessage=u=>{if(!M){_.push(u);return}M=!1,l(u.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/68976705968229accd11fdfe1cba36a908208dc9/core/vs/base/worker/workerMain.js.map
